

/* Begin the CREATE CONFORMAL TO routines ***********************************/

/* NOTE : I don't think that Vector/Mvector conf_to are strictly correct   **/
/*        The routines do not check to see if the vector/mvector is        **/
/*        being created conformal to another (m)vector/p(m)vector.         **/
/*        Further, if you create one conformal to a projected, duplicated  **/
/*        object you do not get a duplicated object -- that is not an      **/
/*        option with (m)vectors.  This sounds minor -- but you can align  **/
/*        a duplicated object in a way that will actually wrap the indices **/
/*        so you are not assured which processor column your new (m)vector **/
/*        will start on.  This may be as intended however.                 **/

int PLA_Vector_create_conf_to(PLA_Obj   laobject,
                              PLA_Obj   *new_vector);

int PLA_Mvector_create_conf_to(PLA_Obj    laobject,
                               int          global_width,
                               PLA_Obj    *new_mvector);

int PLA_Pvector_create_conf_to(PLA_Obj   laobject,
                               int         project_onto,
                               int         owner,
                               PLA_Obj   *new_pvector);

int PLA_Pmvector_create_conf_to(PLA_Obj   laobject,
                                int         project_onto,
                                int         owner,
                                int         global_projected_width,
                                PLA_Obj   *new_pmvector);

int PLA_Matrix_create_conf_to(PLA_Obj   laobject,
                              PLA_Obj   *new_matrix);

int PLA_Mscalar_create_conf_to(PLA_Obj   laobject,
                               int         owner_row,
                               int         owner_col,
                               PLA_Obj   *new_mscalar);



