

/* BEGIN LINEAR ALGEBRA OBJECT DELETION OUTINES **********************/

int PLA_Obj_free(PLA_Obj  *laobj);

/* END LINEAR ALGEBRA OBJECT DELETION OUTINES   **********************/

/***  There are addional ones at the end of this file -- see Appendix A *****/

/**** Begin SPLITTING and SHIFTING Routines *********************************/

int PLA_Obj_split_4(PLA_Obj        laobject,
                      int              upper_length,
                      int              upper_width,
                      PLA_Obj         *upper_left_object,
                      PLA_Obj         *upper_right_object,
                      PLA_Obj         *lower_left_object,
                      PLA_Obj         *lower_right_object);

int PLA_Obj_horz_split_2(PLA_Obj      laobject,
                           int            upper_length,
                           PLA_Obj      *upper_object,
                           PLA_Obj      *lower_object);

int PLA_Obj_vert_split_2(PLA_Obj      laobject,
                           int            left_width,
                           PLA_Obj      *left_object,
                           PLA_Obj      *right_object);

/* The COPY and REDUCE routines **********************************************/

int PLA_Copy(PLA_Obj    laobject_from,   /* Source */
             PLA_Obj    laobject_to);     /* Destination */

int PLA_Reduce(PLA_Obj     laobject_from,  /* Source object - may be dup */
               MPI_Op       operation,
               PLA_Obj     laobject_to);    /* Target object - may be dup */

/**********  Routines from Appendix A                     ********************/


int PLA_Obj_local_ldim  (PLA_Obj      laobject,
                            int          *local_leading_dimension);


