
/***************************************************************************
  03 April 1996 10:11
  
  Copyright (c) 1996 Robert van de Geijn and The University of Texas at Austin.
  See the file GNU_LICENSE for details on the gnu license

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Written by:   Many People including:

  Gregory A. Baker, Center for Space Research,
  University of Texas at Austin  78722      baker@csr.utexas.edu

  Philip A. Alpatov, Department of Physics,
  University of Texas at Austin 78712.     philip@physics.utexas.edu

  James Overfelt, Department of Mathematics,
  University of Texas at Austin  78712.    overfelt@@math.utexas.edu
  
  John Andrew Gunnels, Department of Computer Sciences,
  University of Texas at Austin 78712.     gunnels@@cs.utexas.edu
  
  Greg Morrow, Department of Physics, 
  University of Texas at Austin 78712.     morrow@@physics.utexas.edu
 
  Dr. Robert Van de Geijn, Department of Computer Sciences,
  University of Texas at Austin 78712.     rvdg@@cs.utexas.edu
 
***************************************************************************/



#include "PLA.h"
#include "PLA_Obj_split_9.h"

int PLA_Obj_split_9 ( PLA_Obj a, int left_width, int upper_length,
                                   int middle_width, int middle_length,
                       PLA_Obj * a11, PLA_Obj * a12, PLA_Obj * a13,
                       PLA_Obj * a21, PLA_Obj * a22, PLA_Obj * a23,
                       PLA_Obj * a31, PLA_Obj * a32, PLA_Obj * a33 )
{
   PLA_Obj
      tmp12 = NULL,
      tmp21 = NULL,
      tmp22 = NULL;

   PLA_Obj_split_4 ( a, upper_length, left_width, 
                        a11,   & tmp12,
                      & tmp21, & tmp22 );

   PLA_Obj_vert_split_2 ( tmp12, middle_width, a12, a13 );

   PLA_Obj_horz_split_2 ( tmp21, middle_length, a21,
                                                 a31 );

   PLA_Obj_split_4 ( tmp22, middle_length, middle_width, a22, a23,
                                                          a32, a33 );

   PLA_Obj_free ( & tmp12 );
   PLA_Obj_free ( & tmp21 );
   PLA_Obj_free ( & tmp22 );

   return ( 0 );
}
