#include <mpi.h>
#include <PLA.h>
#include <MISC_DEFS.h>
#include "PRISM.h"

int PRISM_clustered(PLA_Obj lambda_min, PLA_Obj lambda_max, PLA_Obj cur_est) {
/* 
   Return TRUE if lambda_min - lambda_max is small, hence they eigenvalues
   are clustered.
*/

#ifdef DB_GLOBAL_
    if (me==ROOT) printf(">> PRISM_clustered\n");
#endif

    if ( ABS( PRISM_mscalar(lambda_max)-PRISM_mscalar(lambda_min) )  
          < PRISM_mscalar(cur_est) * EPSC ) 
       return TRUE;
    else
       return FALSE;
}
