#include <mpi.h>
#include <PLA.h>
#include <MISC_DEFS.h>
#include "PRISM.h"

void PRISM_enter_on_final_list(PLA_Obj Scur, PLA_Obj Zcur, PLA_Obj Dcur,
                               PRISM_final_list final_list) 
{
     PRISM_subproblem prob;

     PRISM_subproblem_create( &prob );

     /* Copy PLAPACK objects into subproblem structure */
     PLA_Matrix_create_conf_to(Scur, &prob->A);
     PLA_Local_copy( Scur, prob->A );
     PLA_Obj_view_all( Zcur, &prob->Z );
     PLA_Obj_view_all( Dcur, &prob->D );

     PRISM_final_list_insert( prob, final_list );
 
#ifdef DB_GLOBAL_
     if (me==ROOT) printf(">> PRISM_enter_on_final_list\n");
     PRISM_print(prob->A);
     PRISM_print(prob->Z);
#endif
}

