#include "PLA.h"
#include "math.h"
#include "PRISM.h"

/* The following will go into an included .h file */
#define SKIP
#define PRISM_PRT_

int tnb;
int skip_flag;
int skipcount=0;

void prism_pla_pnlqr(PLA_Obj A, PLA_Obj W, PLA_Obj Y, PLA_Obj Z, int bnd);
int mowner(PLA_Obj x);
 
/****************************************************************/

void prism_pla_sbndrd(PLA_Obj A, PLA_Obj Q, int nb, int bnd)
{

  int 
    idummy, info, k, pnlsz, iwork, g_l, jwork,
    cols, m, n, im, in;

  PLA_Obj 
    work=NULL,
    Wv = NULL,     Yv = NULL,     Zv = NULL, 
    Wcur = NULL,  Ycur = NULL,  Zcur = NULL, Atemp = NULL,
    Ytemp = NULL, Ztemp = NULL, A22 = NULL, Wtemp = NULL,
    Qcur = NULL,    Acur = NULL,    star =NULL,
    Rwork=NULL,  Cwork=NULL;

  PLA_Obj 
    PLA_ONE=NULL,
    PLA_ZERO=NULL;
  
  MPI_Datatype
    datatype;
  
  PLA_Template
    template;
  
  void
    *buf_localA = NULL,
    *one_buf,
    *zero_buf;

  char
    trans[1],
    notrans[1];

  double
    r_one=1.0, r_zero=0.0;

  char
    cmach='e';

  info=0;
  PLA_Matrix_global_all( Q, &idummy, &n, &im, &in, &template);

  if( idummy !=n ) 
    info = 1;
  
  PLA_Matrix_global_all( A, &m, &n, &im, &in, &template);

  if( m != n ) 
    info = 2;
  else if (idummy != n) 
    info = 3;

  if (bnd>n-1)
    info=4;

  if (info != 0) {
    if (me==0) printf ("\nPLA_sbndrd.c at node ??: wrong argument (info=%d)\n",info);
    return;
  }


#ifdef SKIP
  BRDEPS = 2*sqrt((double)n)*dlamch_( &cmach );
#else
  BRDEPS = 0.0;
#endif

  PLA_Temp_nb(template, &tnb);

/*create multiscalars PLA_ONE, PLA_ZERO) */
  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 1, 1, 
		     template,&PLA_ONE);
  PLA_Obj_set_to_one(PLA_ONE);
 
  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 1, 1, 
		     template,&PLA_ZERO);
  PLA_Obj_set_to_zero(PLA_ZERO);

  cols=n-bnd-1;
  g_l=cols+1;

  PLA_Mvector_create(MPI_DOUBLE, g_l, nb, template, im+bnd, &Wv);
  PLA_Obj_set_orientation(Wv, PLA_PROJ_ONTO_COL);

  PLA_Mvector_create(MPI_DOUBLE, g_l, nb, template, im+bnd, &Yv);
  PLA_Obj_set_orientation(Yv, PLA_PROJ_ONTO_COL);

  PLA_Obj_view_all( A,  &Acur );
  PLA_Obj_view( Q,  g_l, g_l, bnd, bnd, &Qcur );

  if (bnd<nb){
    PLA_Mvector_create(MPI_DOUBLE, g_l, nb, template, im+bnd, &Zv);
    PLA_Zero_loc_obj(Zv);
    PLA_Obj_set_orientation(Zv, PLA_PROJ_ONTO_COL);
  }

  PLA_Pmvector_create_conf_to(A, PLA_PROJ_ONTO_ROW,PLA_ALL_ROWS,nb,&Rwork);
  PLA_Pmvector_create_conf_to(A, PLA_PROJ_ONTO_COL,PLA_ALL_COLS,nb,&Cwork); 
  PLA_Zero_loc_obj(Rwork);   PLA_Zero_loc_obj(Cwork); 
  idummy=pnlsz=0;

  while(TRUE) {

#ifdef PRISM_PRT_IN
    if (me==0) printf ("<--- SBNDRD at loop %d \n",cols);
#endif
    /* Define submatrices */
    cols -= pnlsz;
    if (cols==0) break;
    pnlsz = min(cols,nb);

    PLA_Obj_view_shift(Yv, idummy, 0, pnlsz-nb, 0);
    PLA_Obj_view_shift(Wv, idummy, 0, pnlsz-nb, 0);
    PLA_Zero_loc_obj(Wv);
    PLA_Zero_loc_obj(Yv);
    PLA_Obj_view_shift(Qcur, 0, idummy, 0, 0);
    if (bnd<nb) {
      PLA_Obj_view_shift(Zv, idummy, 0, pnlsz-nb, 0);
      PLA_Zero_loc_obj(Zv);
    }
    idummy=pnlsz;

    /* panel QR */
    skip_flag=1;
    prism_pla_pnlqr(Acur, Wv, Yv, Zv, bnd);

#ifdef PRISM_PRT_IN
    if (me==0) printf ("<--- Finish QR \n");
#ifdef PRISM_PRT_IN
    if (me==0) printf ("Ycur_qr::\n"); prism_pla_prt_m(Yv);
    if (me==0) printf ("Wcur_qr::\n"); prism_pla_prt_m(Wv);
    if (bnd<nb) {if (me==0) printf ("Zcur_qr::\n"); prism_pla_prt_m(Zv);}
#endif
#endif

    /* Update A22 */
    m=Acur->global_length;
    PLA_Obj_view(Acur,m-pnlsz,m-pnlsz,pnlsz, pnlsz,&A22); 

    if (!skip_flag) {
    if (pnlsz > bnd) {
      PLA_Obj_view(Yv,cols-pnlsz+bnd+1,pnlsz,pnlsz-bnd,0,&Ytemp);
      PLA_Obj_view(Zv,cols-pnlsz+bnd+1,pnlsz,pnlsz-bnd,0,&Ztemp);
      PLA_Gemm_notransa_transb_2(tnb,PLA_NO_TRANS, PLA_TRANS, PLA_ONE , 
				 Ztemp, Ytemp,PLA_ONE, A22);  
      PLA_Gemm_notransa_transb_2(tnb,PLA_NO_TRANS, PLA_TRANS, PLA_ONE , 
				 Ytemp, Ztemp,PLA_ONE, A22);  
    }
    else {
      PLA_Obj_view(Acur, m-bnd, m-pnlsz, bnd, pnlsz, &Atemp);
      iwork=Atemp->global_width;
      PLA_Obj_view(Rwork, pnlsz, iwork, 0, n-iwork, &work);
      if (pnlsz == 1) {
        jwork= Atemp->global_length;
        PLA_Obj_view(Cwork, jwork, 1, n-jwork, 0, &star);
	PLA_Gemv(PLA_TRANS, PLA_ONE, Atemp, Wv, PLA_ZERO, work);
	PLA_Copy(Yv, star);
	PLA_Ger(PLA_ONE, star, work,  Atemp);
      }
      else {
	PLA_Gemm_transa_notransb_1(tnb,PLA_TRANS,PLA_NO_TRANS, PLA_ONE, 
				   Wv, Atemp, PLA_ZERO, work);
	PLA_Gemm_notransa_notransb_1(tnb,PLA_NO_TRANS,PLA_NO_TRANS, PLA_ONE , 
				     Yv, work, PLA_ONE, Atemp);
      }
      PLA_Obj_view(Acur, m-pnlsz, m-bnd, pnlsz, bnd, &Atemp);
      iwork=Atemp->global_length;
      PLA_Obj_view(Cwork, iwork, pnlsz, n-iwork, 0, &work);
      if (pnlsz == 1) {
        jwork= Atemp->global_width;
        PLA_Obj_view(Rwork, 1, jwork,0, n-jwork, &star);
        PLA_Gemv(PLA_NO_TRANS, PLA_ONE, Atemp, Wv, PLA_ZERO, work);
	PLA_Copy(Yv, star);
        PLA_Ger(PLA_ONE, work, star,  Atemp);
      }
      else {
	PLA_Gemm_notransa_notransb_2(tnb, PLA_NO_TRANS,PLA_NO_TRANS,PLA_ONE, 
				     Atemp, Wv, PLA_ZERO, work);
	PLA_Gemm_notransa_transb_2(tnb,PLA_NO_TRANS,PLA_TRANS, PLA_ONE , 
				   work, Yv,PLA_ONE, Atemp); 
      }
    }
    }
    /* else printf("skipping in A22\n"); */

    PLA_Obj_swap(&Acur, &A22);

#ifdef PRISM_PRT_IN
    if (me==0) printf ("<--- Finish A22 \n");
#endif


#ifdef PRISM_PRT_IN
    if (me==0) printf ("For Q-update:: m= %d\n", cols );
#endif
    if (!skip_flag) {
    if (cols+1==n-bnd) {
      if (pnlsz==1) {
	PLA_Copy(Wv, work);
	PLA_Ger(PLA_ONE, work, star,  Qcur);
	}
      else
	PLA_Gemm_notransa_transb_2(tnb,PLA_NO_TRANS,PLA_TRANS, PLA_ONE, 
				   Wv, Yv, PLA_ONE, Qcur);
    }
    else {
      PLA_Obj_view(Cwork, g_l, pnlsz, n-g_l,  0, &work);
      if (pnlsz==1) {
	PLA_Gemv(PLA_NO_TRANS,PLA_ONE,Qcur, Wv, PLA_ZERO, work);
	PLA_Ger(PLA_ONE, work, star, Qcur);
      }
      else {
	PLA_Gemm_notransa_notransb_2(tnb,PLA_NO_TRANS,PLA_NO_TRANS, PLA_ONE, 
				     Qcur, Wv, PLA_ZERO, work);
	PLA_Gemm_notransa_transb_2(tnb,PLA_NO_TRANS,PLA_TRANS, PLA_ONE, 
				   work, Yv, PLA_ONE, Qcur);
      }
    }
    }
     
#ifdef PRISM_PRT_IN
    if (me==0) printf ("<--- Finish Q \n");
#endif

  }
  
  PLA_Obj_free(&Acur);   PLA_Obj_free(&A22);    PLA_Obj_free(&Qcur);
  PLA_Obj_free(&Wv);    PLA_Obj_free(&Yv);  PLA_Obj_free(&Zv);  
  PLA_Obj_free(&Wcur); PLA_Obj_free(&Ycur); PLA_Obj_free(&Zcur);
  PLA_Obj_free(&Ytemp); PLA_Obj_free(&Ztemp); PLA_Obj_free(&Atemp);
  PLA_Obj_free(&star); PLA_Obj_free(&Wtemp); PLA_Obj_free(&work);   
  PLA_Obj_free(&PLA_ONE); PLA_Obj_free(&PLA_ZERO);
  PLA_Obj_free(&Rwork); PLA_Obj_free(&Cwork);
}
void prism_pla_pnlqr(PLA_Obj A, PLA_Obj W, PLA_Obj Y, PLA_Obj Z, int bnd)
{


  int 
    m, n, pnlsz, omit, info, col;

  PLA_Obj 
    Acur=NULL,     A22 = NULL,    norm=NULL,
    a = NULL,      atop = NULL, 
    wQ = NULL,     Y1 = NULL,    Z1 = NULL,
    Wcur = NULL,   Ycur = NULL,    
    w = NULL,     z = NULL,      y = NULL,      
    wcur = NULL,  ycur = NULL,   zcur = NULL,  acur = NULL,      
    ymat = NULL,  zmat = NULL,  rwork2 = NULL,
    rwork1 = NULL,  cwork=NULL, star =NULL;

  PLA_Obj 
    min_beta=NULL,
    alpha=NULL,
    PLA_ONE=NULL,
    PLA_ZERO=NULL;
  
  MPI_Datatype
    datatype;
  
  MPI_Comm
    comm1d;

  PLA_Template
    template;

  int
    i_one=1, i_zero=0;

  char
    trans[1],
    notrans[1];

  double
    NORM,diag;

  void
    *alpha_buf = NULL,
    *min_beta_buf = NULL,
    *buf_localA = NULL,*norm_buf=NULL,
    *rwork1_buf,
    *rwork2_buf,
    *a_buf;

  double
    r_one=1.0, r_zero=0.0;

  *(trans)='T';
  *(notrans)='N';

  PLA_Base_comm(&comm1d);
  PLA_Obj_global_width( W, &pnlsz);
  PLA_Obj_global_length( W, &n);
  PLA_Obj_template( A, &template);
  PLA_Obj_datatype( A, &datatype);

#ifdef PRISM_PRT
  if (me==0) {printf("Obj A "); prism_pla_ginfo(A);}
#endif

  /*create multiscalars PLA_ONE, PLA_ZERO) */
  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 1, 1, 
		     template,&PLA_ONE);
  PLA_Obj_set_to_one(PLA_ONE);

  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 1, 1, 
		     template,&PLA_ZERO);
  PLA_Obj_set_to_zero(PLA_ZERO);

  /*  create mscalars alpha, min_beta */
  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 1, 1, 
		     template,&alpha);
  PLA_Obj_local_buffer(alpha, &alpha_buf);

  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 1, 1, 
		     template,&min_beta);
  PLA_Obj_local_buffer(min_beta, &min_beta_buf);

  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 1, 1, 
		     template,&norm);
  PLA_Obj_local_buffer(norm, &norm_buf);

  PLA_Mvector_create(MPI_DOUBLE,n,pnlsz,template,W->global_align_row,&cwork);
  PLA_Obj_view(A, n, pnlsz, bnd, 0, &Acur);
  PLA_Copy(Acur, cwork);

  PLA_Obj_view(cwork, n, 1, 0, 0, &a);  
  PLA_Obj_view(A, n, n, bnd, bnd, &A22);  
  PLA_Obj_view(W,PLA_DIM_ALL,1,PLA_ALIGN_FIRST,PLA_ALIGN_FIRST, &w);  
  PLA_Obj_view(Y,PLA_DIM_ALL,1,PLA_ALIGN_FIRST,PLA_ALIGN_FIRST, &y);  
  PLA_Obj_view(W,PLA_DIM_ALL,1,PLA_ALIGN_FIRST,PLA_ALIGN_FIRST, &wQ);  
  PLA_Obj_view(Y,PLA_DIM_ALL,1,PLA_ALIGN_FIRST,PLA_ALIGN_FIRST,&ycur); 
  PLA_Obj_view(a,PLA_DIM_ALL,1,PLA_ALIGN_FIRST,PLA_ALIGN_FIRST,&acur); 
  PLA_Obj_view(w,PLA_DIM_ALL,1,PLA_ALIGN_FIRST,PLA_ALIGN_FIRST,&wcur); 
  PLA_Obj_set_orientation(a, PLA_PROJ_ONTO_COL);
  PLA_Obj_set_orientation(w, PLA_PROJ_ONTO_COL);
  PLA_Obj_set_orientation(acur, PLA_PROJ_ONTO_COL);
  PLA_Obj_set_orientation(wcur, PLA_PROJ_ONTO_COL);
  PLA_Obj_set_orientation(ycur, PLA_PROJ_ONTO_COL);

  PLA_Obj_view(Y,PLA_DIM_ALL,0,PLA_ALIGN_FIRST,PLA_ALIGN_FIRST,&Ycur);
  PLA_Obj_view(W,PLA_DIM_ALL,0,PLA_ALIGN_FIRST,PLA_ALIGN_FIRST,&Wcur);
  PLA_Obj_view(Y,PLA_DIM_ALL,0,PLA_ALIGN_FIRST,PLA_ALIGN_FIRST,&Y1);

  if (pnlsz>bnd) { 
    PLA_Obj_view(Z,PLA_DIM_ALL,1,PLA_ALIGN_FIRST,PLA_ALIGN_FIRST,&z);
    PLA_Obj_view(Z,PLA_DIM_ALL,0,PLA_ALIGN_FIRST,PLA_ALIGN_FIRST,&Z1);
    PLA_Obj_view(Z, 1,bnd,PLA_ALIGN_FIRST, PLA_ALIGN_FIRST,&zmat);
    PLA_Obj_view(Y, 1,bnd,PLA_ALIGN_FIRST, PLA_ALIGN_FIRST,&ymat);
    PLA_Obj_set_orientation(z, PLA_PROJ_ONTO_COL);
  }

  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 1, pnlsz,
		     template, &rwork1);
  PLA_Zero_loc_obj(rwork1); 
  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 1, pnlsz,
		     template, &rwork2);
  PLA_Zero_loc_obj(rwork2); 

  PLA_Obj_local_buffer(rwork1, &rwork1_buf);
  PLA_Obj_local_buffer(rwork2, &rwork2_buf);


#ifdef PRISM_PRT_IN
  if (me==0) printf ("Start pnlqr--->\n");
#endif

  col=omit=0;
  while(TRUE) {
#ifdef PRISM_PRT_IN
    if (me==0) printf ("col= %d; Start update a--->\n",col);
#endif
    /* update a */
    /*** NOTE:: W1, Y1, Z1 will be defined in the end since they
         are not used in the first round  ***/

    if (col!=0) {
      rwork1->global_width=rwork1->local_width=col;
      rwork2->global_width=rwork2->local_width=col;

      if (col < bnd) {
        PLA_Local_gemv(PLA_TRANS, PLA_ONE, Wcur, a, PLA_ZERO, rwork1);
	  MPI_Allreduce((double *)rwork1_buf,(double *)rwork2_buf, col,
		      MPI_DOUBLE, MPI_SUM, comm1d);
        PLA_Local_gemv(PLA_NO_TRANS, PLA_ONE, Ycur, rwork2, PLA_ONE, a);
      }
      else {
	/*
      if (me==0) printf("zmat:\n");
	PRISM_print(Z1); 
	PRISM_print(zmat); 
	*/
	PLA_Copy(zmat, rwork1);
	PLA_Local_gemv(PLA_NO_TRANS, PLA_ONE, Y1, rwork1, PLA_ONE, a);
	PLA_Copy(ymat, rwork1);
	PLA_Local_gemv(PLA_NO_TRANS, PLA_ONE, Z1, rwork1, PLA_ONE, a);
      }    
    }


#ifdef PRISM_PRT_IN
    if (me==0) printf ("Start computing hhv--->\n");
#endif
    /* compute hhv (y) */
    PLA_Dot(acur, acur, norm);
    /*
    PRISM_print(acur);
    PRISM_print(norm);
    */

    if (pnlsz>bnd && col>=bnd) {
      PLA_Obj_view_shift(A22, 1, 1, 0,0);
      PLA_Obj_view_shift(Z1, 1, 0, 0, 0); 
      PLA_Obj_view_shift(Y1, 1, 0, 0, 0); 
    }

    NORM = sqrt(*((double *)norm_buf));

#ifdef PRISM_PRT_IN
   if (me == 0) printf("NORM=%8.4e  ",NORM);
#endif

    if (NORM <= BRDEPS) {
      /* skipcount++;  if (me==0) printf("skip no. %d\n",skipcount);  */
    }
    else {
      skip_flag=0;
      PLA_Obj_horz_split_2(acur, 1, &atop, &star);
      if (mowner(atop)) {
	PLA_Obj_local_buffer(atop, &a_buf);
	diag = *((double *)a_buf);
        diag+=SIGN(diag)*NORM;
	*((double *)a_buf) = diag;
	PLA_Local_copy( acur, ycur);
	diag=SIGN(diag)*(-NORM);
	*((double *)a_buf) = diag;
      }
      else {
	PLA_Local_copy( acur, ycur);
      }

      PLA_Dot(ycur,ycur, norm);
      NORM = *((double *)norm_buf);
      NORM=-2.0/NORM;
      *((double*)min_beta_buf) = NORM;
    

#ifdef PRISM_PRT_IN
   if (me == 0) {
     printf("m_beta=%8.4e \n", *((double *)min_beta_buf));
     printf ("Start computing w--->\n");
   }
#endif
      /* compute w */
      PLA_Local_copy( ycur, wcur);
      PLA_Scal( min_beta, wcur);

#ifdef PRISM_PRT_IN
      if (me==0) printf ("Start computing z--->\n");
#endif
      /* compute z */
      if (pnlsz>bnd) {
	Gemv(PLA_NO_TRANS, PLA_ONE, A22, w, PLA_ZERO, z);
	if (col > 0) {
	  PLA_Local_gemv(PLA_TRANS, PLA_ONE, Z1, w, PLA_ZERO, rwork1);
	  MPI_Allreduce((double *)rwork1_buf,(double *)rwork2_buf, col,
			MPI_DOUBLE, MPI_SUM, comm1d);
	  PLA_Local_gemv(PLA_NO_TRANS, PLA_ONE, Y1, rwork2, PLA_ONE, z);

	  PLA_Local_gemv(PLA_TRANS, PLA_ONE, Y1, w, PLA_ZERO, rwork1);
	  MPI_Allreduce((double *)rwork1_buf,(double *)rwork2_buf, col,
			MPI_DOUBLE, MPI_SUM, comm1d);
	  PLA_Local_gemv(PLA_NO_TRANS, PLA_ONE, Z1, rwork2, PLA_ONE, z);
	}
	PLA_Dot(w, z, alpha);
	*((double *) alpha_buf) = *((double *) alpha_buf) /2;
	PLA_Local_axpy(alpha, y, z);

#ifdef PRISM_PRT_IN
	if (me == 0) {
	  printf("coefficient = %8.4e \n -------- \n",*((double *) alpha_buf));
  	}
#endif
      }


      /* update w for Q */
#ifdef PRISM_PRT_IN
      if (me==0) printf ("Start computing w for W--->\n");
#endif
      if (col > 0 ) { 
	PLA_Local_gemv(PLA_TRANS, PLA_ONE, Ycur, wQ, PLA_ZERO, rwork1);
	MPI_Allreduce((double *)rwork1_buf,(double *)rwork2_buf, col,
		      MPI_DOUBLE, MPI_SUM, comm1d);
	PLA_Local_gemv(PLA_NO_TRANS, PLA_ONE, Wcur, rwork2, PLA_ONE, wQ);
      }
    } /* end of SKIP */

    col++;
    if (col==pnlsz) break;

    if (pnlsz>bnd) {
      if (col>bnd) {
	PLA_Obj_view_shift(zmat, 1, 0, 1, 1);
	PLA_Obj_view_shift(ymat, 1, 0, 1, 1);
      }
      PLA_Obj_view_shift(w, (col<bnd)?0:1, 1, 1, 0);
      PLA_Obj_view_shift(y, (col<bnd)?0:1, 1, 1, 0);
      PLA_Obj_view_shift(z, (col<bnd)?0:1, 1, 1, 0);
      PLA_Obj_view_shift(Z1, 0, 0, 1, 0); 
      PLA_Obj_view_shift(Y1, 0, 0, 1, 0); 
    }
    PLA_Obj_view_shift(wQ, 0, 1, 1, 0);
    PLA_Obj_view_shift(a, (col<=bnd)?0:1, 1, 1, 0);
    PLA_Obj_view_shift(acur, 1, 1, 1, 0);
    PLA_Obj_view_shift(ycur, 1, 1, 1, 0);
    PLA_Obj_view_shift(wcur, 1, 1, 1, 0);
    PLA_Obj_view_shift(Ycur, 0, 0, 1, 0); 
    PLA_Obj_view_shift(Wcur, 0, 0, 1, 0);

  }  /* end of WHILE */
  PLA_Obj_view_shift(cwork, 0, 0, 0, -n+pnlsz);
  PLA_Obj_view_shift(Acur, 0, 0, 0, -n+pnlsz);
  PLA_Copy(cwork, Acur);

  PLA_Obj_free(&Acur);   PLA_Obj_free(&A22); PLA_Obj_free(&norm);   
  PLA_Obj_free(&a);   PLA_Obj_free(&atop);
  PLA_Obj_free(&Wcur);   PLA_Obj_free(&Y1);    PLA_Obj_free(&Z1);
  PLA_Obj_free(&wQ);   PLA_Obj_free(&Ycur);  
  PLA_Obj_free(&w);   PLA_Obj_free(&z);PLA_Obj_free(&y);
  PLA_Obj_free(&wcur);   PLA_Obj_free(&ycur);    PLA_Obj_free(&zcur);
  PLA_Obj_free(&acur); 
  PLA_Obj_free(&ymat);    PLA_Obj_free(&zmat);PLA_Obj_free(&rwork2);
  PLA_Obj_free(&rwork1);    PLA_Obj_free(&star); PLA_Obj_free(&cwork);
  PLA_Obj_free(&PLA_ONE); PLA_Obj_free(&PLA_ZERO);
  PLA_Obj_free(&alpha); PLA_Obj_free(&min_beta); 
}

int mowner(PLA_Obj x)
{
  int 
    length, width; 
   
  PLA_Obj_local_width(x, &width);
  PLA_Obj_local_length(x, &length);
  if (length==1 &&  width==1 )
    return 1;
  else
    return 0;
}




