/************************************************************
*     File: p3d.c
* This file contains application functions.
*
************************************************************
* 
* Modified by:
*             Adnan Agbaria
*
**********************************************************************/


#include "ns3d.h"
#include <stdio.h>
#include <math.h>
#include <sys/time.h>
#include <sys/times.h>
#include <sys/types.h>
#include <errno.h>

#define DEBUG 1

#define max(x,y)      ((x)>(y)?(x):(y))
#define min(x,y)      ((x)<(y)?(x):(y))
#define MOD(x,y)      ((x)%(y))

/***********************************************************
* External variable.
************************************************************/
extern int me;

/*--------------------------------------
|     PROCESSOR
|
*/
void  strip(tur,tul,tvr,tvl,twr,twl,
	    yur,yul,yvr,yvl,ywr,ywl,
	    tbul,tbur,tdul,tdur,
	    tbvl,tbvr,tdvl,tdvr,
	    tbwl,tbwr,tdwl,tdwr,
	    ybpl,ybpr,ydpl,ydpr,
	    ybul,ybur,ydul,ydur,
	    ybvl,ybvr,ydvl,ydvr,
	    ybwl,ybwr,ydwl,ydwr,
	    nenter,out_file,nn,
	    work,trigs,ywork,ytrigs,zwork,ztrigs,ifax,icfax,iyfax,izfax,
	    am,ab,
	    yk1,yk2,zk1,zk2,xk1,xk2,wnz, wnzd,b,s,c,par,
	    uu,uul,uus,uup,ue,
	    vv,vvl,vvs,vvp,ve,
	    ww,wwl,wws,wwp,we,
	    vd,wd,
	    gt,gm,gl,ht,hm,hl,lt,lm,ll,
	    fa,fb,fc,fd,ga,gb,gc,gd,ra,rb,rc,rd,
	    lchu,lchv,lchw,loop,begTime,begBuf)
int *nenter;
FILE *out_file;

float
tur[KK2][MM2][NEP1+NEM+1], tul[KK2][MM2][NEP1+NEM+1],
  tvr[KK2][MM2][NEP1+NEM+1], tvl[KK2][MM2][NEP1+NEM+1],
  twr[KK2][MM2][NEP1+NEM+1], twl[KK2][MM2][NEP1+NEM+1],
  yur[KK2][MM2][NEP1+NEM+1], yul[KK2][MM2][NEP1+NEM+1],
  yvr[KK2][MM2][NEP1+NEM+1], yvl[KK2][MM2][NEP1+NEM+1],
  ywr[KK2][MM2][NEP1+NEM+1], ywl[KK2][MM2][NEP1+NEM+1],
  tbul[KK2][MM2], tbur[KK2][MM2], tbvl[KK2][MM2], tbvr[KK2][MM2],
  tbwl[KK2][MM2], tbwr[KK2][MM2],
  tdul[KK2][MM2], tdur[KK2][MM2], tdvl[KK2][MM2], tdvr[KK2][MM2],
  tdwl[KK2][MM2], tdwr[KK2][MM2],
  ybul[KK2][MM2], ybur[KK2][MM2], ybvl[KK2][MM2], ybvr[KK2][MM2],
  ybwl[KK2][MM2], ybwr[KK2][MM2],
  ydul[KK2][MM2], ydur[KK2][MM2], ydvl[KK2][MM2], ydvr[KK2][MM2],
  ydwl[KK2][MM2], ydwr[KK2][MM2];

float
ybpl[NPR][KK2][MM2],ybpr[NPR][KK2][MM2],ydpl[NPR][KK2][MM2],
  ydpr[NPR][KK2][MM2];

float work[NWORK],trigs[NTRIG];
int ifax[13],icfax[13];
float ywork[MWORK],ytrigs[MTRIG];
int iyfax[13];
float zwork[KWORK], ztrigs[KTRIG];
int izfax[13];
float yk1[MMYH],yk2[MMYH],zk1[MM2],zk2[MM2];
float wnz[KKZH],wnzd[KK2];
float xk1[NXH],xk2[NXH];
float b[NXH],s[NEP1+NEM+1],c[NEP1+NEM+1];
float par[25];
float am[NPR],ab[NPR];
float
uu[KK2][MM2][NDM], vv[KK2][MM2][NDM], ww[KK2][MM2][NDM],
  uul[KK2][MM2][NDM], vvl[KK2][MM2][NDM], wwl[KK2][MM2][NDM],
  uus[KK2][MM2][NDM], vvs[KK2][MM2][NDM], wws[KK2][MM2][NDM],
  uup[KK2][MM2][NDM], vvp[KK2][MM2][NDM], wwp[KK2][MM2][NDM],
  ue[KK2][MM2][NDM], ve[KK2][MM2][NDM], we[KK2][MM2][NDM],
  vd[KK2][MM2][NDM], wd[KK2][MM2][NDM],
  fa[KK2][MM2][NDM], fb[KK2][MM2][NDM], fc[KK2][MM2][NDM],fd[KK2][MM2][NDM],
  ga[KK2][MM2][NDM], gb[KK2][MM2][NDM], gc[KK2][MM2][NDM],gd[KK2][MM2][NDM],
  ra[KK2][MM2][NDM], rb[KK2][MM2][NDM], rc[KK2][MM2][NDM],rd[KK2][MM2][NDM],
  gt[KK2][MM2][NDM], gm[KK2][MM2][NDM], gl[KK2][MM2][NDM],
  ht[KK2][MM2][NDM], hm[KK2][MM2][NDM], hl[KK2][MM2][NDM],
  lt[KK2][MM2][NDM], lm[KK2][MM2][NDM], ll[KK2][MM2][NDM];

int
lchu[KK2][MM2],lchv[KK2][MM2],lchw[KK2][MM2];
int loop;
struct timeval begTime;
struct tms begBuf;
{
  extern void 
    fftfax(),wavenum(),fold(),exsol(),timfc(),initial(),nonlin(),
    copyt(),explic(),overlap(),dery(),derz(),derivx(),rhsp(),solpart(),level(),
    aver(),gmatch(),match3(),rhsim(),match1(),match2(),error();


  /*
    par[0]=pi
    par[1]=de
    par[2]=dey
    par[3]=dl
    par[4]=dl1
    par[5]=eps
    par[6]=dlr
    par[7]=dly
    par[8]=re
    par[9]=dt
    par[10]=et
    par[11]=al1
    par[12]=tn
    par[13]=am1
    par[14]=am2
    par[15]=am3
    par[16]=ab1
    par[17]=ab2
    par[18]=ab3
    par[19]=pav
    par[20]=asq1
    par[21]=nstep
    par[22]=tt
    */
  int kx,ky,lx,ly;
  float pi,de,dey,dez,dl,dl1,eps,dt,al1,tn,wk,re;
  float dlr,dly,dlz;
  float et,tt,asq1,pav;
  float am1,am2,am3,ab1,ab2,ab3;
  
  static int K1;
  static int K3 = -1;
  static int K4 = 1;
  float cum[MM2][NDM],cvm[MM2][NDM];
  static int T1,T2,T3,nift,j,D6,lc,D8,imod;
  static float ewr[NEXT+NEM+1],wu[NDM],ewu[NEM+NEXT+1],
    wudp[NDM],wr[NDM],wuu[NDM],wud[NDM],al,umax,umin,r1,r2,bl,br,drl,drr,
    cbl,cbr,cdrl,cdrr,cc,dd,err,err1;
  static float tg,tgd;
  float asp,sav;
  int i,k;
  int nstep;
  int nnn;
  
  /*Timing.*/
  long tickTime;
  long utime, time;
  float allTime;
  int nPoint;
  struct timeval endTime;
  struct tms endBuf;
  
  nnn=nn;
  
  if(*nenter == 0){

    T1 = N;
    fftfax(&T1,ifax,trigs);
    
    T2 = MM;
    fftfax(&T2,iyfax,ytrigs);
    
    T3 = KK;
    fftfax(&T3,izfax,ztrigs);
    
    /*--------------------------*/
    /*   parameters             */
    /*--------------------------*/
    tn=0.0;
    dt = 0.001;
    wk=1.0;
    kx = ky = lx = ly = 1;
    et=0.01;
    pav=0.0;
    asq1=11.0/(6.0*dt*et);
    al1 = sqrt(asq1);
    am1=3.0;
    am2=1.5;
    am3=1.0/3.0;
    ab1=3.0;
    ab2=3.0;
    ab3=1.0;
    
    /*
      par[0]=pi
      par[1]=de
      par[2]=dey
      par[3]=dl
      par[4]=dl1
      par[5]=eps
      par[6]=dlr;
      par[7]=dly;
      par[8]=re;
      par[9]=dt;
      par[10]=et;
      par[11]=al1;
      par[12]=tn
      par[13]=am1;
      par[14]=am2;
      par[15]=am3;
      par[16]=ab1;
      par[17]=ab2;
      par[18]=ab3;
      par[19]=pav;
      par[20]=asq1;
      */

    par[13]=am1;
    par[14]=am2;
    par[15]=am3;
    par[16]=ab1;
    par[17]=ab2;
    par[18]=ab3;
    par[19]=pav;
    par[20]=asq1;
    
    wavenum(par,xk1,xk2,zk1,zk2,yk1,yk2,wnz,wnzd);
    
    pi  = par[0];
    de  = par[1];
    dey = par[2];
    dl  = par[3];
    dl1 = par[4];
    eps = par[5];
    dlr = par[6];
    dly = par[7];
    re =  par[8];
    dlz = par[23];
    dez = par[24];

    fold(pi,de,eps,b,s,c);
    exsol(pi,de,dey,dez,et,dl1,
	  fa,fb,fc,fd,ga,gb,gc,gd,ra,rb,rc,rd,
	  ue,ve,we,nnn,wk,
	  ywork,ytrigs,iyfax,zwork,ztrigs,izfax);
    
    tt = -2.0 * dt;
    timfc(pi,tt,&tg,&tgd);
    initial(pi,dl1,de,dey,dez,wk,tg,uul,vvl,wwl,vd,wd,nnn,
	    ywork,ytrigs,iyfax,zwork,ztrigs,izfax);
    nonlin(uul,gm,vvl,vd,hm,wwl,wd,lm,ywork,ytrigs,iyfax,yk1,
	   zwork,ztrigs,izfax,wnz);
    
    tt=-dt;
    timfc(pi,tt,&tg,&tgd);
    initial(pi,dl1,de,dey,dez,wk,tg,uu,vv,ww,vd,wd,nnn,
	    ywork,ytrigs,iyfax,zwork,ztrigs,izfax);
    nonlin(uu,gt,vv,vd,ht,ww,wd,lt,ywork,ytrigs,iyfax,yk1,
	   zwork,ztrigs,izfax,wnz);
    
    tt=0.0;
    timfc(pi,tt,&tg,&tgd);
    initial(pi,dl1,de,dey,dez,wk,tg,uup,vvp,wwp,vd,wd,nnn,
	    ywork,ytrigs,iyfax,zwork,ztrigs,izfax);
    
    par[9]=dt;
    par[10]=et;
    par[11]=al1;
    par[12]=tn;

    return;
  } /* if(*nenter == 0)  */
  
  if(*nenter == 1){
    
    /*------------------------------------------------------*/
    /* Updaing U,V, NL                                      */
    /*------------------------------------------------------*/
    pi=par[0];
    dt=par[9];
    tn=par[12];
    tt=tn+dt*(float)loop;
    par[22]=tt;
    
    timfc(pi,tt,&tg,&tgd);
    
    /*-------------------*/
    /* n-2 time step     */
    /*-------------------*/
    for( k = 0; k < KK2; k++ ){
      copyt(uul[k],uus[k]);
      copyt(gm[k],gl[k]);
      copyt(vvl[k],vvs[k]);
      copyt(hm[k],hl[k]);
      copyt(wwl[k],wws[k]);
      copyt(lm[k],ll[k]);
      
      /*-------------------*/
      /* n-1 time step     */
      /*-------------------*/
      copyt(uu[k],uul[k]);
      copyt(gt[k],gm[k]);
      copyt(vv[k],vvl[k]);
      copyt(ht[k],hm[k]);
      copyt(ww[k],wwl[k]);
      copyt(lt[k],lm[k]);
      
      /*-------------------*/
      /* n   time step     */
      /*-------------------*/
      copyt(uup[k],uu[k]);
      copyt(vvp[k],vv[k]);
      copyt(wwp[k],ww[k]);
    }
    
    nonlin(uu,gt,vv,vd,ht,ww,wd,lt,ywork,ytrigs,iyfax,yk1,
	   zwork,ztrigs,izfax,wnz);
    
    /*------------------------------------------------------*/
    /* Explicit step                                        */
    /* uus as ^u, vvs as ^v, wws as ^w                      */
    /*------------------------------------------------------*/
    nift = (NDM)-(NEPT);
    
    for( k = 0; k < KK2; k++ ){
      explic(par, gt[k], gm[k], gl[k], uu[k], uul[k], uus[k], tg,
	     tgd, fa[k], fb[k], fc[k], fd[k]);
      explic(par, ht[k], hm[k], hl[k], vv[k], vvl[k], vvs[k], tg,
	     tgd, ga[k], gb[k], gc[k], gd[k]);
      explic(par, lt[k], lm[k], ll[k], ww[k], wwl[k], wws[k], tg,
	     tgd, ra[k], rb[k], rc[k], rd[k]);
      
      overlap(uus[k],tul[k],tur[k],nift);
    }
    return;
  } /* if (*nenter == 1) */
  
  if (*nenter == 2) {
    
    /*------------------------------------------------------*/
    /* Poission equation                                    */
    /*   ^Ux -> GL,  ^Vy -> HL                              */
    /*------------------------------------------------------*/
    nift = (NDM)-(NEPT);
    
    for( k = 0; k < KK2; k++ ){
      dery(vvs[k], hl[k], yk1 );
      derivx(uus[k],yul[k],yur[k],gl[k],wu,ewu,work,trigs,ifax,b,s,c,xk1);
    }
    derz( wws, ll, wnz );
    for( k = 0; k < KK2; k++ ){
      rhsp(gl[k],hl[k],ll[k],par[9]);
      overlap(hl[k],tul[k],tur[k],nift);
    }
    return;
  } /*  if(*nenter == 2) */

  if(*nenter == 3){
    asp = 0.0;
    for( k = 0; k < KK2; k++ ){
      solpart(gl[k], hl[k], hl[k], yul[k], yur[k], tbul[k], tbur[k],
	      tdul[k], tdur[k], lchu[k], asp, zk2, work, trigs, 
	      xk1, xk2, b, s, c, ifax, wnzd[k]);
    }
    j = 1;
    K1=-1;
    level(hl[0],wu,&j,&K1);
    aver(wu,&sav);
    tbul[0][0]=sav;
  } /*  if(*nenter == 3) */
  
  if(*nenter == 4){
    
    /*----------------------------------------------------*/
    /* This step is performed only in the processor P1 (!) */
    /*----------------------------------------------------*/
    /*
      |compute matching parameters cc(n,j), dd(n,j)
      |
      |ybpl(n,j), ybpr(n,j), ydpl(n,j), ydpr(n,j) are the corresponding
      |boundary conditions transferred from a processor "n" (n > 1)
      |(for n=1  boundary conditions remain in  tbul,tbur,tdul,tdur)
      |
      | results: n > 1,  cc(n,j) in  ybpl(n,j),   dd(n,j) in ybpr(n,j)
      |          n = 1,  cc(j) in  tbul(j),   dd(j) in tbur(j)
      |
      |   for j=1:  alph_n  in  ybpl(n,1),      n>1
      |             alph_1  in  tbul(1),        n=1
      ******************************************************************/
    dl1=par[4];
    pav=par[19];
    gmatch(ybpl, ybpr, ydpl, ydpr, dl1, tbul, tbur, tdul, tdur, lchu,
	   zk1, pav, wnzd);
  } /*  if(*nenter == 4) */
  
  if(*nenter == 5){

    /*
      |  matching P
      |
      |  CC(n,j) in  TBUL(j),   DD(n,j) in TBUR(j)
      |
      |  for j=1:  alph_n  in  TBUL(1)
      */
    /*---------------------------*/
    /*   Py in GL,   Px in HL    */
    /*---------------------------*/
    de=par[1];
    dl1=par[4];
    match3(gl, hl, tbul, tbur, zk1, de, dl1, wnzd);
    derz(gl, ll, wnz); 
    for( k = 0; k < KK2; k++ )
      dery(gl[k], gl[k], yk1);
    
    /*--------------------------------------------------*/
    /*   end Poisson                                    */
    /*   Implicit step                                  */
    /*  RHS= - {^^U/(ET*DT), ^^V/(ET*DT) }  in  {GL,HL} */
    /*  ^^U/ET=^U/ET-Px,  ^^V/ET=^V/ET-Py               */
    /*--------------------------------------------------*/
    dt=par[9];
    et=par[10];
    for( k = 0; k < KK2; k++ )
      rhsim(uus[k], vvs[k], wws[k], hl[k], gl[k], ll[k], dt, et);
    
    nift = (NDM)-(NEPT);
    for( k = 0; k < KK2; k++ ){
      overlap(gl[k],tul[k],tur[k],nift);
      overlap(hl[k],tvl[k],tvr[k],nift);
      overlap(ll[k],twl[k],twr[k],nift);
    }
  } /*  if(*nenter == 5) */
  
  if(*nenter == 6){
    
    /*-------------------*/
    /*   U particular    */
    /*-------------------*/
    asq1=par[20];
    for( k = 0; k < KK2; k++ )
      solpart(uup[k], vd[k], gl[k], yul[k], yur[k], tbul[k], tbur[k],
	      tdul[k], tdur[k], lchu[k], asq1, zk2, work, trigs,
	      xk1, xk2, b, s, c, ifax, wnzd[k]);
    
    /*-------------------*/
    /*   V particular    */
    /*-------------------*/
    for( k = 0; k < KK2; k++ )
      solpart(vvp[k], vd[k], hl[k], yvl[k], yvr[k], tbvl[k], tbvr[k],
	      tdvl[k], tdvr[k], lchv[k], asq1, zk2, work, trigs, xk1, xk2, b,
	      s, c, ifax, wnzd[k]);
    
    /*-------------------*/
    /*   W particular    */
    /*-------------------*/
    for( k = 0; k < KK2; k++ )
      solpart(wwp[k], wd[k], ll[k], ywl[k], ywr[k], tbwl[k], tbwr[k],
	      tdwl[k], tdwr[k], lchw[k], asq1, zk2, work, trigs, xk1, xk2, b,
	      s, c, ifax, wnzd[k]);

  } /*  if(*nenter == 6) */
  
  if(*nenter == 7){
    
    /*-------------------*/
    /*   matching U      */
    /*-------------------*/
    asq1=par[20];
    de=par[1];
    dl1=par[4];
    for( k = 0; k < KK2; k++ )
      match1(uup[k], ybul[k], ybur[k], ydul[k], ydur[k], tbul[k],
	     tbur[k], tdul[k], tdur[k], lchu[k], zk2,
	     asq1, de, dl1, wnzd[k]);
    
    /*-------------------*/
    /*   matching V      */
    /*-------------------*/
    for( k = 0; k < KK2; k++ )
      match2(vvp[k], vd[k], ybvl[k], ybvr[k], ydvl[k], ydvr[k],
	     tbvl[k], tbvr[k], tdvl[k], tdvr[k], lchv[k],
	     zk2, asq1, de, dl1, wnzd[k]);
    
    /*-------------------*/
    /*   matching w      */
    /*-------------------*/
    for( k = 0; k < KK2; k++ )
      match2(wwp[k], wd[k], ybwl[k], ybwr[k], ydwl[k], ydwr[k],
	     tbwl[k], tbwr[k], tdwl[k], tdwr[k], lchw[k],
	     zk2, asq1, de, dl1, wnzd[k]);
    
    /***************************************************/
    /*            OUTPUT                               */
    /***************************************************/
    pi  = par[0];
    tt=par[22];
    
    if( me == 0 ){
      timfc(pi,tt,&tg,&tgd);
      printf("nstep = %d\n", loop);
      error(uup,ue,&err,tg);
    }
    
    if (loop == (int)par[21]){
      if( gettimeofday(&endTime, (struct timezone*)0) < 0 )
	perror( "gettimeofday" );
      if( times( &endBuf ) < 0 )
	perror( "times" );
      
      tickTime = (endBuf.tms_stime - begBuf.tms_stime);
      time = (endTime.tv_sec - begTime.tv_sec);
      utime = (endTime.tv_usec - begTime.tv_usec);
      allTime = (utime/1.e6);
      allTime += time;
      nPoint = N/2-2*NEP;
      pi  = par[0];
      tt=par[22];
      timfc(pi, tt, &tg, &tgd);
      error(uup,ue,&err,tg);
      error(vvp,ve,&err1,tg);
      if( err1 < err )
	err1 = err;
      
      error(wwp,we,&err,tg);
      if( err < err1 )
	err = err1;

      fprintf(out_file, "P = %d, N = %d, err = %g and nstep = %d\n", 
	      NPR, N, err, (int)par[21]);
      fprintf(out_file, "The time is %g\n\n", allTime);
    }
    
    return;
  }  /* if(*nenter == 7) */
  
} /* end of strip */


/*******************************************************************
* Function:  wavenum()
*
*******************************************************************/
void wavenum(par, xk1, xk2, zk1, zk2, yk1, yk2, wnz, wnzd)
float *par;
float *xk1,*xk2;
float *yk1,*yk2,*zk1,*zk2;
float *wnz, *wnzd;
{
  /*
    par[0]=pi
    par[1]=de
    par[2]=dey
    par[3]=dl
    par[4]=dl1
    par[5]=eps
    par[6]=dlr;
    par[7]=dly;
    par[8]=re;
    */
  
  float pi,de,dey,dl,dl1,dly,dlr,eps;
  int kx,ky,lx,ly;
  float dez,dlz;
  
  static int i,ii1,ii2;
  static float pi2,re;
  
  pi = 4.0*atan(1.0);
  pi2 = 2.0*(pi);
  dlr=pi2;
  dly=pi2;
  dlz=pi2;
  dl1 = dlr/(float)NPR;
  dey = dly/(float)MM;
  dez = dlz/(float)KK;
  re = 4.0*(float)NEP/((float)(N));
  dl = dl1/(1.0-re);
  de = dl/((float)(NH));
  eps = de*(float)NEP;
  
  par[0]=pi;
  par[1]=de;
  par[2]=dey;
  par[3]=dl;
  par[4]=dl1;
  par[5]=eps;
  par[6]=dlr;
  par[7]=dly;
  par[8]=re;
  par[23]=dlz;
  par[24]=dez;
  
  for(i=0; i<(NXH); i++) {
    xk1[i] = (float)(float)i*(pi)/(dl);
    xk2[i] = xk1[i]*xk1[i];
  }
  for(i=1; i<=(MMYH); i++) {
    ii1 = 2*i-1;
    ii2 = 2*i;
    zk1[ii1-1] = zk1[ii2-1] = (float)(i-1)*((float)dly)/pi2;
    zk2[ii1-1] = zk1[ii1-1]*zk1[ii1-1];
    zk2[ii2-1] = zk1[ii2-1]*zk1[ii2-1];
    yk1[i-1] = yk1[i-1] = (float)(i-1)*(float)dly/pi2;;
    yk2[i-1] = yk1[i-1]*yk1[i-1];
  }
  for(i=1; i<=(KKZH); i++) {
    ii1 = 2*i-1;
    ii2 = 2*i;
    wnz[i-1] = (float)(i-1)*(float)dlz/pi2;
    wnzd[ii1-1] = wnzd[ii2-1] = wnz[i-1];
  }
  return;
}


/*******************************************************************
* Function: fold()
* 
********************************************************************/
void fold(pi, de, eps, b, s, c)
/*-----------------*/
/*   new variant   */
/*-----------------*/
float *b,*s,*c;
float pi,de,eps;
{
  float teta[NEPT];
  float dey,dl,dl1;
  int kx,ky,lx,ly;
  
  static int i,ii1,ii2;
  static float xx,rr,r1,r2,r3,arg;
  
  for(i=0; i<(NEPT); i++) {
    xx = (float)i*de-eps;
    rr = 0.5*pi*xx/eps;
    r1 = 0.5*pi*sin(rr);
    r2 = 0.5*pi*sin(r1);
    r3 = 0.5*pi*sin(r2);
    teta[i] = 0.25*pi*(1.0+sin(r2));
  }
  for (i=1; i<=(NEPT); i++) {
    arg = teta[i-1];
    *(s+i-(NEP)+NEM) = sin(arg);
  }
  for(i=1; i<=(NEPT); i++) {
    arg = teta[i-1];
    *(c+i-(NEP)+NEM) = cos(arg);
  }
  for(i=1; i<=(NEP1); i++) *(b+i-1) = *(s+i+NEM);

  ii1 = (NEP1)+1;
  ii2 = (NXH)-(NEP1);
  for(i=ii1; i<=ii2; i++) *(b+i-1) = 1.0;
  ii1 = (NXH)-(NEP);
  ii2 = (NXH);
  for(i=ii1; i<=ii2; i++) *(b+i-1) = *(c+i-(NH)+NEM);
  return;
}


/***********************************************************************
*  Function: exsol()
*
*
*  W=g(t)*{exp[cos(K*X)*cos(K*Y)*cos(K*Z)]}
*  g(t)={.1*exp[sin2t - 3*sin (2*pi*t)] + cos(2sqrt(2*t))}/40 + .375/5
*
* 
*************************************************************************/
void exsol(pi, de, dey, dez, et, dl1,
	   fa, fb, fc, fd, ga, gb, gc, gd, ra, rb, rc, rd,
	   ue, ve, we, nn, wk, ywork, ytrigs, iyfax, zwork, ztrigs, izfax)
float pi, de, dey, dez, et, dl1, wk;
int nn;
float ywork[MWORK], ytrigs[MTRIG];
int *iyfax;
float zwork[KWORK], ztrigs[KTRIG];
int *izfax;
float
fa[KK2][MM2][NDM],fb[KK2][MM2][NDM],fc[KK2][MM2][NDM],fd[KK2][MM2][NDM],
  ga[KK2][MM2][NDM],gb[KK2][MM2][NDM],gc[KK2][MM2][NDM],gd[KK2][MM2][NDM],
  ra[KK2][MM2][NDM],rb[KK2][MM2][NDM],rc[KK2][MM2][NDM],rd[KK2][MM2][NDM],
  ue[KK2][MM2][NDM],ve[KK2][MM2][NDM],we[KK2][MM2][NDM];
{
  /*----------------------------------------------------*/
  /* INIT.DISTR. in PHYS.SPACE - TRANSFORM in Y-direct. */
  /*----------------------------------------------------*/
  extern void ffty(), fftz();
  
  static int K1 = -1;
  int i, j, k, ksq, lsq;
  float xx, yy, zz, exy, exz, eyz;
  float skx, ckx, s2kx, c2kx, sky, cky, skz, ckz;
  float arg1, arg2, arg3, arg4;
  float pi2, k1, k2, k3;
  float ux, uy, uz, vx, vy, vz, wx, wy, wz, rotx, roty, rotz;
  float uxx, uxxp, uyy, uzz, vxx, vyy, vyyp, vzz, wxx, wyy, wzz, wzzp;
  float s2x, s2y, s2z;
  
  pi2 = 2.0*pi;
  k1=wk;
  k2=pow(wk,2.0);
  k3=pow(wk,3.0);
  
  for(i=0; i<(NDM); i++){
    xx = de*(float)i+(float)(nn-1)*dl1;
    arg1 = xx*wk;
    ckx = cos(arg1);
    skx = sin(arg1);
    c2kx = cos(2.*arg1);
    s2kx = sin(2.*arg1);
    s2x = skx*skx;
    for( j = 0; j < MM; j++ ){
      yy = (float)j*dey;
      arg2 = yy*wk;
      cky = cos(arg2);
      sky = sin(arg2);
      s2y = sky*sky;
      exy = exp(ckx*cky);
      for( k = 0; k < KK; k++ ){
	zz = (float)k*dez;
	arg3 = zz*wk;
	ckz = cos(arg3);
	skz = sin(arg3);
	s2z = skz*skz;
	exz = exp(ckx*ckz);
	eyz = exp(cky*ckz);
	
	ue[k][j][i] = wk*ckx*( skz*exz - sky*exy );
	ve[k][j][i] = wk*cky*( skx*exy - skz*eyz );
	we[k][j][i] = wk*ckz*( sky*eyz - skx*exz );
	
	/**
	  derivatives of velocity
	  **/
	ux = -k2*skz*skx*( 1. + ckx*ckz )*exz +
	  k2*sky*skx*( 1. + ckx*cky )*exy;
	uy = k2*ckx*exy*( s2y*ckx - cky );
	uz = -k2*ckx*exz*( s2z*ckx - ckz );
	
	vx = -k2*cky*exy*( s2x*cky - ckx );
	vy = -k2*skx*sky*( 1. + ckx*cky )*exy +
	  k2*sky*skz*( 1. + ckz*cky )*eyz;
	vz = k2*cky*eyz*( s2z*cky - ckz );
	
	wx = k2*ckz*exz*( s2x*ckz - ckx );
	wy = -k2*ckz*eyz*( s2y*ckz - cky );
	wz = -k2*skz*sky*( 1. + cky*ckz )*eyz +
	  k2*skx*skz*( 1. + ckx*ckz )*exz;
	
	rotx = wy - vz;
	roty = uz - wx;
	rotz = vx - uy;
	/**
	  second derivatives of velocity
	  **/
	uxx = ( 1. + ckx*ckz )*( ckx - s2x*ckz );
	uxx = -k3*skz*exz*( uxx - s2x*ckz );
	uxxp = ( 1. + ckx*cky )*( ckx - s2x*cky );
	uxxp = k3*sky*exy*( uxxp - s2x*cky );
	uxx += uxxp;
	
	uyy = ckx*sky*( 3.*cky - s2y*ckx ) + sky;
	uyy *= k3*ckx*exy;
	
	uzz = ckx*skz*( 3.*ckz - s2z*ckx ) + skz;
	uzz *= -k3*ckx*exz;
	
	vxx = cky*skx*( 3.*ckx - s2x*cky ) + skx;
	vxx *= -k3*cky*exy;
	
	vyy = ( 1. + cky*ckx )*( cky - s2y*ckx );
	vyy = -k3*skx*exy*( vyy - s2y*ckx );
	vyyp = ( 1. + cky*ckz )*( cky - s2y*ckz );
	vyyp = k3*skz*eyz*( vyyp - s2y*ckz );
	vyy += vyyp;
	
	vzz = cky*skz*( 3.*ckz - s2z*cky ) + skz;
	vzz *= k3*cky*eyz;
	
	wxx = ckz*skx*( 3.*ckx - s2x*ckz ) + skx;
	wxx *= k3*ckz*exz;
	
	wyy = ckz*sky*( 3.*cky - s2y*ckz ) + sky;
	wyy *= -k3*ckz*eyz;
	
	wzz = ( 1. + ckz*cky )*( ckz - s2z*cky );
	wzz = -k3*sky*eyz*( wzz - s2z*cky );
	wzzp = ( 1. + ckx*ckz )*( ckz - s2z*ckx );
	wzzp = k3*skx*exz*( wzzp - s2z*ckx );
	wzz += wzzp;
	
	/**
	  to compensate terms in left side: fa, fc, fd are taken with
	  opposite sign, fb with the same sign
	  **/
	fb[k][j][i] = ue[k][j][i];
	fc[k][j][i] = -ve[k][j][i]*rotz -
	  we[k][j][i]*roty;
	fa[k][j][i] = -et*( uxx + uyy + uzz );
	fd[k][j][i] = 0.0;

	/**
	  fa[k][j][i] = et*k2*ue[k][j][i];
	  fd[k][j][i] = 2.*s2kx*ckz;
	  fd[k][j][i] = 2.*s2kx*cky*ckz;
	  **/
	
	gb[k][j][i] = ve[k][j][i];
	gc[k][j][i] = ue[k][j][i]*rotz -
	  we[k][j][i]*rotx;
	ga[k][j][i] = -et*( vxx + vyy + vzz );
	gd[k][j][i] = 0.0;

	/**
	  ga[k][j][i] = et*k2*ve[k][j][i];
	  gd[k][j][i] = c2kx*sky*ckz;
	  **/
	
	rb[k][j][i] = we[k][j][i];
	rc[k][j][i] = (ue[k][j][i])*roty +
	  (ve[k][j][i])*rotx;
	ra[k][j][i] = -et*( wxx + wyy + wzz );
	rd[k][j][i] = 0.0;
	
	/**
	  ra[k][j][i] = et*k2*we[k][j][i];
	  rd[k][j][i] = c2kx*skz;
	  rd[k][j][i] = c2kx*cky*skz;
	  **/
      }
    }
  }
  /**
    last elements
    **/
  for( i = 0; i < NDM; i++ )
    for( j = 0; j < (MM+2); j++ ){
      ue[KK][j][i] = ue[KK+1][j][i] = 0.0;
      ve[KK][j][i] = ve[KK+1][j][i] = 0.0;
      we[KK][j][i] = we[KK+1][j][i] = 0.0;
      
      fa[KK][j][i] = fa[KK+1][j][i] = 0.0;
      fb[KK][j][i] = fb[KK+1][j][i] = 0.0;
      fc[KK][j][i] = fc[KK+1][j][i] = 0.0;
      fd[KK][j][i] = fd[KK+1][j][i] = 0.0;
      
      ga[KK][j][i] = ga[KK+1][j][i] = 0.0;
      gb[KK][j][i] = gb[KK+1][j][i] = 0.0;
      gc[KK][j][i] = gc[KK+1][j][i] = 0.0;
      gd[KK][j][i] = gd[KK+1][j][i] = 0.0;
      
      ra[KK][j][i] = ra[KK+1][j][i] = 0.0;
      rb[KK][j][i] = rb[KK+1][j][i] = 0.0;
      rc[KK][j][i] = rc[KK+1][j][i] = 0.0;
      rd[KK][j][i] = rd[KK+1][j][i] = 0.0;
    }
  
  for( i = 0; i < NDM; i++ )
    for( k = 0; k < (KK); k++ ){
      ue[k][MM][i] = ue[k][MM+1][i] = 0.0;
      ve[k][MM][i] = ve[k][MM+1][i] = 0.0;
      we[k][MM][i] = we[k][MM+1][i] = 0.0;
      
      fa[k][MM][i] = fa[k][MM+1][i] = 0.0;
      fb[k][MM][i] = fb[k][MM+1][i] = 0.0;
      fc[k][MM][i] = fc[k][MM+1][i] = 0.0;
      fd[k][MM][i] = fd[k][MM+1][i] = 0.0;
      
      ga[k][MM][i] = ga[k][MM+1][i] = 0.0;
      gb[k][MM][i] = gb[k][MM+1][i] = 0.0;
      gc[k][MM][i] = gc[k][MM+1][i] = 0.0;
      gd[k][MM][i] = gd[k][MM+1][i] = 0.0;
      
      ra[k][MM][i] = ra[k][MM+1][i] = 0.0;
      rb[k][MM][i] = rb[k][MM+1][i] = 0.0;
      rc[k][MM][i] = rc[k][MM+1][i] = 0.0;
      rd[k][MM][i] = rd[k][MM+1][i] = 0.0;
    }
  
  /*-----------------------------------*/
  /* TRANSFORM in Z-direct.            */
  /*-----------------------------------*/
  
  fftz(fa,&K1,zwork,ztrigs,izfax);
  fftz(fb,&K1,zwork,ztrigs,izfax);
  fftz(fc,&K1,zwork,ztrigs,izfax);
  fftz(fd,&K1,zwork,ztrigs,izfax);
  
  fftz(ga,&K1,zwork,ztrigs,izfax);
  fftz(gb,&K1,zwork,ztrigs,izfax);
  fftz(gc,&K1,zwork,ztrigs,izfax);
  fftz(gd,&K1,zwork,ztrigs,izfax);
  
  fftz(ra,&K1,zwork,ztrigs,izfax);
  fftz(rb,&K1,zwork,ztrigs,izfax);
  fftz(rc,&K1,zwork,ztrigs,izfax);

  fftz(rd,&K1,zwork,ztrigs,izfax);
  
  fftz(ue,&K1,zwork,ztrigs,izfax);
  fftz(ve,&K1,zwork,ztrigs,izfax);
  fftz(we,&K1,zwork,ztrigs,izfax);
  
  /*-----------------------------------*/
  /* TRANSFORM in Y-direct.            */
  /*-----------------------------------*/
  for( k = 0; k < KK2; k++ ){
    ffty(fa[k],&K1,ywork,ytrigs,iyfax);
    ffty(fb[k],&K1,ywork,ytrigs,iyfax);
    ffty(fc[k],&K1,ywork,ytrigs,iyfax);
    ffty(fd[k],&K1,ywork,ytrigs,iyfax);
    
    ffty(ga[k],&K1,ywork,ytrigs,iyfax);
    ffty(gb[k],&K1,ywork,ytrigs,iyfax);
    ffty(gc[k],&K1,ywork,ytrigs,iyfax);
    ffty(gd[k],&K1,ywork,ytrigs,iyfax);
    
    ffty(ra[k],&K1,ywork,ytrigs,iyfax);
    ffty(rb[k],&K1,ywork,ytrigs,iyfax);
    ffty(rc[k],&K1,ywork,ytrigs,iyfax);
    ffty(rd[k],&K1,ywork,ytrigs,iyfax);
    
    ffty(ue[k],&K1,ywork,ytrigs,iyfax);
    ffty(ve[k],&K1,ywork,ytrigs,iyfax);
    ffty(we[k],&K1,ywork,ytrigs,iyfax);
  }
  return;
}


/***********************************************************************
* Function: ffty()
*
***********************************************************************/
void ffty(a, isign, ywork, ytrigs, iyfax)
int *isign;
float *a;
float ywork[MWORK],ytrigs[MTRIG];
int iyfax[13];
{
  extern void fft991();
  
  static int inc,jump,len,lot;
  
  inc = NDM;
  jump = 1;
  len = MM;
  lot = NDM;
  fft991(a,ywork,ytrigs,iyfax,&inc,&jump,&len,&lot,isign);
  return;
}


/*********************************************************************
* Function: fftz()
*
***********************************************************************/
void fftz(a, isign, zwork, ztrigs, izfax)
int *isign;
float *a;
float zwork[KWORK],ztrigs[KTRIG];
int izfax[13];
{
  extern void fft991();
  
  static int inc,jump,len,lot;
  
  inc = NDM*(MM+2);
  jump = 1;
  len = KK;
  lot = NDM*(MM+2);
  fft991(a,zwork,ztrigs,izfax,&inc,&jump,&len,&lot,isign);
  return;
}


/*******************************************************************
* Function: timfc()
*
********************************************************************/
void timfc(pi, tt, tg, tgd)
float pi,tt,*tg,*tgd;
{
  float pi2,r1,r2,r3,r4,rex;

  pi2=2.0*pi;
  r1=sin(2.0*tt)-3.0*sin(pi2*tt);
  rex=exp(r1);
  r2=2.0*cos(2.0*tt)-6.0*pi*cos(pi2*tt);
  r3=2.0*sqrt(2.0);
  r4=0.375/5.0;
  *tg=0.025*(0.1*rex+cos(r3*tt))+r4;
  *tgd=0.025*(0.1*rex*r2-r3*sin(r3*tt));
  return;
}


/**********************************************************************
* Function: initial()
*
***********************************************************************/
void initial(pi, dl1, de, dey, dez, wk, tg, uu, vv, ww, vd, wd, nnn,
		ywork, ytrigs, iyfax, zwork, ztrigs, izfax)
float pi,de,dey,dez,dl1,wk,tg;
float
uu[KK2][MM2][NDM],vv[KK2][MM2][NDM],ww[KK2][MM2][NDM],
  vd[KK2][MM2][NDM],wd[KK2][MM2][NDM];
float ywork[MWORK],ytrigs[MTRIG],zwork[KWORK],ztrigs[KTRIG];
int *iyfax,*izfax;
int nnn;
{
  /*--------------------------------------------------------*/
  /* INIT.DISTR. in PHYS.SPACE - TRANSFORM in Y and Z direct*/
  /*--------------------------------------------------------*/
  /* vd = vx, wd = wx - derivatives                         */
  /**********************************************************/
  
  extern void ffty(), fftz();
  
  static int K1 = -1;
  static int i,j,k;
  static float pi2,xx,yy,zz,arg1,arg2,arg3;
  static float skx,ckx,sky,cky,skz,ckz,k1,k2;
  float exy, exz, eyz, s2x;
  
  pi2 = 2.0*pi;
  k1=wk*tg;
  k2=k1*wk;
  for(i=0; i<(NDM); i++){
    xx = de*(float)i+(float)(nnn-1)*dl1;
    arg1 = xx*wk;
    ckx = cos(arg1);
    skx = sin(arg1);
    s2x = skx*skx;

    for(j=0; j<(MM); j++){
      yy = (float)j*dey;
      arg2 = yy*wk;
      cky = cos(arg2);
      sky = sin(arg2);
      exy = exp(ckx*cky);

      for( k = 0; k < KK; k++ ){
	zz = (float)k*dez;
	arg3 = zz*wk;
	ckz = cos(arg3);
	skz = sin(arg3);
	exz = exp(ckx*ckz);
	eyz = exp(cky*ckz);
	
	uu[k][j][i] = k1*ckx*( skz*exz - sky*exy );
	vv[k][j][i] = k1*cky*( skx*exy - skz*eyz );
	ww[k][j][i] = k1*ckz*( sky*eyz - skx*exz );
	vd[k][j][i] = -k2*cky*exy*( s2x*cky - ckx );
	wd[k][j][i] = k2*ckz*exz*( s2x*ckz - ckx );
      } 
    }
  }
  
  /*****************************/
  /*  last elements.           */
  /*****************************/
  for( i = 0; i < NDM; i++ )
    for( j = 0; j < (MM+2); j++ ){
      uu[KK][j][i] = uu[KK+1][j][i] = 0.0;
      vv[KK][j][i] = vv[KK+1][j][i] = 0.0;
      ww[KK][j][i] = ww[KK+1][j][i] = 0.0;
      vd[KK][j][i] = vd[KK+1][j][i] = 0.0;
      wd[KK][j][i] = wd[KK+1][j][i] = 0.0;
      
    }
  for( i = 0; i < NDM; i++ )
    for( k = 0; k < (KK); k++ ){
      uu[k][MM][i] = uu[k][MM+1][i] = 0.0;
      vv[k][MM][i] = vv[k][MM+1][i] = 0.0;
      ww[k][MM][i] = ww[k][MM+1][i] = 0.0;
      vd[k][MM][i] = vd[k][MM+1][i] = 0.0;
      wd[k][MM][i] = wd[k][MM+1][i] = 0.0;

    }

  /*-----------------------------------*/
  /* TRANSFORM in Z-direct.            */
  /*-----------------------------------*/
  fftz(uu,&K1,zwork,ztrigs,izfax);
  fftz(vv,&K1,zwork,ztrigs,izfax);
  fftz(ww,&K1,zwork,ztrigs,izfax);
  fftz(vd,&K1,zwork,ztrigs,izfax);
  fftz(wd,&K1,zwork,ztrigs,izfax);

  /*-----------------------------------*/
  /* TRANSFORM in Y-direct.            */
  /*-----------------------------------*/
  for( k = 0; k < KK2; k++ ){
    ffty(uu[k],&K1,ywork,ytrigs,iyfax);
    ffty(vv[k],&K1,ywork,ytrigs,iyfax);
    ffty(ww[k],&K1,ywork,ytrigs,iyfax);
    ffty(vd[k],&K1,ywork,ytrigs,iyfax);
    ffty(wd[k],&K1,ywork,ytrigs,iyfax);
  }
  
  return;
}


/***********************************************************************
* Function: nonlin()
*
*     Input and output in Fourier space
*     NL={G,H}
*     G=-C V,  H = C U;   C=Vx-Uy (vorticity)
*
************************************************************************/
void nonlin(uu, gt, vv, vd, ht, ww, wd, lt,
	    ywork, ytrigs, iyfax, yk1, zwork, ztrigs, izfax, wnz)
float
uu[KK2][MM2][NDM],gt[KK2][MM2][NDM],
  vv[KK2][MM2][NDM],vd[KK2][MM2][NDM],ht[KK2][MM2][NDM],
  ww[KK2][MM2][NDM],wd[KK2][MM2][NDM],lt[KK2][MM2][NDM];
float *ywork,*ytrigs,*zwork,*ztrigs;
int *iyfax, *izfax;
float *yk1, *wnz;
{
  extern void copyt(),dery(),derz(),ffty(),fftz();
  static int K1 = 1;
  static int K2 = -1;
  float uy[KK2][MM2][NDM], wy[KK2][MM2][NDM], 
    uz[KK2][MM2][NDM], vz[KK2][MM2][NDM];
  int i,j,k;
  
  /*---------------------------------*/
  /* y derivatives in Fourier space  */
  /*---------------------------------*/
  for( i = 0; i < KK2; i++ ){
    dery( uu[i], uy[i], yk1 );
    dery( ww[i], wy[i], yk1 );
  }

  /*--------------------------------*/
  /* z derivatives in Fourier space */
  /*--------------------------------*/
  derz( uu, uz, wnz );
  derz( vv, vz, wnz );
  
  /*--------------------*/
  /* differences        */
  /*--------------------*/
  for( k = 0; k < KK2; k++ )
    for (i=0;i<MM2;i++)
      for(j=0; j<NDM;j++){
	vd[k][i][j] = vd[k][i][j] - uy[k][i][j];
	uz[k][i][j] = uz[k][i][j] - wd[k][i][j];
	wy[k][i][j] = wy[k][i][j] - vz[k][i][j];
      }
  
  /*--------------------------------------------*/
  /* copying velocities as we need them further */
  /*--------------------------------------------*/
  for( k = 0; k < KK2; k++ ){
    copyt( uu[k], uy[k] );
    copyt( vv[k], vz[k] );
    copyt( ww[k], wd[k] );
  } 
  
  /*------------------------*/
  /* inverse transforms     */
  /*------------------------*/
  fftz(vd,&K1,zwork,ztrigs,izfax);
  fftz(uz,&K1,zwork,ztrigs,izfax);
  fftz(wy,&K1,zwork,ztrigs,izfax);
  
  fftz(uy,&K1,zwork,ztrigs,izfax);
  fftz(vz,&K1,zwork,ztrigs,izfax);
  fftz(wd,&K1,zwork,ztrigs,izfax);
  
  for( k = 0; k < KK2; k++ ){
    ffty(vd[k],&K1,ywork,ytrigs,iyfax);
    ffty(uz[k],&K1,ywork,ytrigs,iyfax);
    ffty(wy[k],&K1,ywork,ytrigs,iyfax);
    
    ffty(uy[k],&K1,ywork,ytrigs,iyfax);
    ffty(vz[k],&K1,ywork,ytrigs,iyfax);
    ffty(wd[k],&K1,ywork,ytrigs,iyfax);
  }
  
  /*-----------------------------------*/
  /* nonlinear terms in physical space */
  /*-----------------------------------*/
  for( k = 0; k < KK2; k++ )
    for (i=0;i<MM2;i++)
      for(j=0; j<NDM;j++){
	gt[k][i][j] = -vz[k][i][j]*vd[k][i][j] - wd[k][i][j]*uz[k][i][j]; 
	ht[k][i][j] = uy[k][i][j]*vd[k][i][j] - wd[k][i][j]*wy[k][i][j];
	lt[k][i][j] = uy[k][i][j]*uz[k][i][j] + vz[k][i][j]*wy[k][i][j];
      }
  
  /*-----------------------------------*/
  /* nonlinear terms in Fourier space  */
  /*-----------------------------------*/
  fftz(gt,&K2,zwork,ztrigs,izfax);
  fftz(ht,&K2,zwork,ztrigs,izfax);
  fftz(lt,&K2,zwork,ztrigs,izfax);
  for( k = 0; k < KK2; k++ ){
    ffty(gt[k],&K2,ywork,ytrigs,iyfax);
    ffty(ht[k],&K2,ywork,ytrigs,iyfax);
    ffty(lt[k],&K2,ywork,ytrigs,iyfax);
  }
  return;
}


/*******************************************************************
* Function: dery()
*
********************************************************************/
void dery(af, bf, yk1)
float af[MM2][NDM],bf[MM2][NDM];
float *yk1;
{
  /*----------------*/
  /*   BF=i*Ky*AF   */
  /*----------------*/
  
  static int i,j,jj1,jj2;
  static float zz,r1;

  for(i=0; i<NDM; i++) {
    for(j=1; j<=(MMYH); j++) {
      jj1 = 2*j-1;
      jj2 = 2*j;
      zz = yk1[j-1];
      r1=af[jj1-1][i];
      bf[jj1-1][i] = -af[jj2-1][i]*zz;
      bf[jj2-1][i] = r1*zz;
    }
  }
  return;
}


/*******************************************************************
* Function: derz()
*
*********************************************************************/
void derz(af, bf, wnz)
float af[KK2][MM2][NDM],bf[KK2][MM2][NDM];
float *wnz;
{
  /*----------------*/
  /*   BF=i*WNZ*AF   */
  /*----------------*/

  static int i,j,k,jj1,jj2;
  static float zz,r1;

  for(i=0; i<NDM; i++) {
    for(k=0; k<MM2; k++ ) {
      for(j=1; j<=(KKZH); j++) {
	jj1 = 2*j-1;
	jj2 = 2*j;
	zz = wnz[j-1];
	r1=af[jj1-1][k][i];
	bf[jj1-1][k][i] = -af[jj2-1][k][i]*zz;
	bf[jj2-1][k][i] = r1*zz;
      }
    }
  }
  return;
}


/*******************************************************************
* Function: copyt()
*
*********************************************************************/
void copyt(a, a1)
float  a[MM2][NDM],a1[MM2][NDM];
{
  static int i,j;
  
  for(i=0; i<(NDM); i++) {
    for(j=0; j<(MM2); j++) a1[j][i] = a[j][i];
  }
  return;
}


/*******************************************************************
* Function: explic()
*
********************************************************************/
void explic(par, gt, gm, gl, uu, uul, uus, tg, tgd, fa, fb, fc, fd)
float *par;
float
gt[MM2][NDM],gm[MM2][NDM],gl[MM2][NDM];
float
uu[MM2][NDM],uul[MM2][NDM],uus[MM2][NDM];
float tg,tgd;
float
fa[MM2][NDM],fb[MM2][NDM],fc[MM2][NDM],fd[MM2][NDM];
{
  float r1,r2,r3,dt,tgs,am1,am2,am3,ab1,ab2,ab3;
  int i,j;
  
  dt  = par[9];
  am1 = par[13];
  am2 = par[14];
  am3 = par[15];
  
  ab1 = par[16];
  ab2 = par[17];
  ab3 = par[18];
  
  tgs=tg*tg;
  
  for (i=0;i<NDM;i++)
    for (j=0;j<=MM1;j++){
      r1 = ab1*gt[j][i] - ab2*gm[j][i] + ab3*gl[j][i];
      r2 = am1*uu[j][i] - am2*uul[j][i] + am3*uus[j][i];
      r3 = tg*fa[j][i] + tgd*fb[j][i]+tgs*fc[j][i]+fd[j][i];
      uus[j][i] = r2 - r1*dt + r3*dt;
    }
  return;
}


/*******************************************************************
* Function:  overlap()
*
********************************************************************/
void overlap(ru, tul, tur, nift)
float ru[MM2][NDM];
float tur[MM2][NEP1+NEM+1],tul[MM2][NEP1+NEM+1];
int nift;
{
  static int j,i;
  
  for(j=0; j<=(MM1); j++) {
    for(i=1; i<=(NEPT); i++) {
      tul[j][i-(NEP)+(NEM)] = ru[j][i-1];
      tur[j][i-(NEP)+(NEM)] = ru[j][i+nift-1]; 
    }
  }
  return;
}


/*******************************************************************
* Function: derivx()
*
*********************************************************************/
void derivx(uu, yl, yr, gg, wu, ewu,
	    work, trigs, ifax, b, s, c, xk1)
float uu[MM2][NDM],yl[MM2][NEP1+NEM+1],gg[MM2][NDM],yr[MM2][NEP1+NEM+1];
float wu[NDM],ewu[NEM+NEXT+1];
float *work,*trigs;
int *ifax;
float *b,*s,*c;
float xk1[NXH];
{
  
  extern void level(),expand(),difx();
  static int K1=-1;
  static int K2=1;
  static int j,i;
  
  for(j=1; j<=MM2; j++) {
    /*
      if (j==2) continue;
      */
    level(uu,wu,&j,&K1);

    expand(wu,yr,yl,ewu,&j);
    
    difx(ewu,wu,work,trigs,ifax,b,s,c,xk1);
    
    level(gg,wu,&j,&K2);
  }
}


/*******************************************************************
* Function: level()
*
*    WE  to ARR     ILV=1
*    ARR to WE      ILV=-1
*
********************************************************************/
void level(arr, we, jj, ilv)
int *jj,*ilv;
float arr[MM2][NDM],we[NDM];
{
  static int i;

  if(*ilv == 1) {
    for(i=0; i<(NDM); i++) arr[*jj-1][i] = we[i];
  }
  else  {
    for(i=0; i<(NDM); i++) we[i] = arr[*jj-1][i];
  }
  return;
}


/*******************************************************************
* Function: expand()
*
*********************************************************************/
void expand(wr, yur, yul, ewr, jj)
int *jj;
float wr[NDM],yur[MM2][NEP1+NEM+1],yul[MM2][NEP1+NEM+1],ewr[NEXT+NEM+1];
{
  static int i;

  for(i=1; i<=(NDM); i++) ewr[i+(NEP)+(NEM)]= wr[i-1];
  for(i= -(NEM); i<=(NEP); i++) {
    ewr[i+(NEM)] = yul[(*jj)-1][i+(NEM)];
    ewr[i+(NXH)+(NEM)] = yur[(*jj)-1][i+(NEM)+1];
  }
  return;
}


/*********************************************************************
* Function: difx()
*
***********************************************************************/
void difx(rhl, wu, work, trigs, ifax, b, s, c, xk1)
float rhl[NEM+NEXT+1],wu[NDM];
float *work,*trigs;
int *ifax;
float *b,*s,*c;
float xk1[NXH];
{
  extern void project(),extend(),fft1(),der1(),fftinvers();
  float z[NXH],a[M][NP2];
  int i,j;
  
  project(rhl,z,b,s,c);
  extend(a,z);
  fft1(a,work,trigs,ifax);
  der1(a,xk1);
  fftinvers(a,work,trigs,ifax);
  for (i=0;i<NDM;i++)
    wu[i] = a[0][i+NEP];
  return;
}


/*******************************************************************
* Function: project()
*
*********************************************************************/
void project(fi, z, b, s, c)
float fi[NEXT+NEM+1],z[NXH];
float *b,*s,*c;
{
  static int i,ii2;
  
  for(i=0; i<NXH; i++) 
    z[i] = b[i]*fi[i+(NEM)+1];
  for(i=1; i<=NEP1; i++) 
    z[i-1] -= (s[-i+(NEM)+2]*fi[-i+2+(NEM)]);
  ii2 = (NXH)-(NEP1);
  for(i=1; i<=NEP1; i++) 
    z[i+ii2-1] -= (s[i-(NEP)+(NEM)]*fi[-i+(NXH)+(NEP1)+(NEM)]);
  return;
}


/*********************************************************************
* Function: extend()
*
*********************************************************************/
void extend(a, z)
float a[M][NP2],z[NXH];
{
  static int j,i;

  for(j=0; j<M; j++) {
    for(i=1; i<=NH; i++) {
      a[j][i-1] = z[i-1];
      a[j][(NP2)-i-1] = -z[i-1];
    }
    a[j][(NXH)-1] = a[j][(NP1)-1] = a[j][(NP2)-1] = 0.0;
  }
  return;
}


/*********************************************************************
* Function: fft1()
*
*********************************************************************/
void fft1(a, work, trigs, ifax)
float *a;
float *work,*trigs;
int *ifax;
{
  extern void fft991();
  static int inc,jump,T1,T2,isign;
  
  isign=-1;
  inc = 1;
  jump = NP2;
  T1 = N;
  T2 = 1;
  
  fft991(a,work,trigs,ifax,&inc,&jump,&T1,&T2,&isign);
  return;
}


/*********************************************************************
* Function: der1()
*
***********************************************************************/
void der1(a, xk1)
float a[M][NP2],xk1[NXH];
{
  static int i,ii1,ii2;
  static float zz,rr;

  for(i=1; i<=(NXH); i++) {
    ii1 = 2*i-1;
    ii2 = 2*i;
    zz = xk1[i-1];
    rr = a[0][ii1-1];
    a[0][ii1-1] = -a[0][ii2-1]*zz;
    a[0][ii2-1] = zz*rr;
  }
  return;
}


/*******************************************************************
* Function: fftinvers()
*
*********************************************************************/
void fftinvers(a, work, trigs, ifax)
float *a;
float *work,*trigs;
int *ifax;
{
  /*---------------------------------------------------------------*/
  /* A(0),B(0),A(1),B(1),...A(N/2),B(N/2) are transformed to U(J): */
  /* U(J)=SUM(K=0,...,N-1)(C(K)*EXP(2*i*J*K*PI/N),                 */
  /* C(K)=A(K)+i*B(K), C(N-K)=A(K)-i*B(K)                          */
  /*---------------------------------------------------------------*/
  extern void fft991();
  
  static int K2 = 1;
  static int isign,inc,jump,T1;

  isign = inc = 1;
  jump = NP2;
  T1 = N;
  fft991(a,work,trigs,ifax,&inc,&jump,&T1,&K2,&isign);
  return;
}


/*******************************************************************
* Function: rhsp()
*
*********************************************************************/
void rhsp(gl, hl, ll, dt)
float gl[MM2][NDM],hl[MM2][NDM],ll[MM2][NDM];
float dt;
{
  float r1;
  int i,j;
  
  for (j=0;j<=MM1;j++)
    for (i=0;i<NDM;i++){
      r1=gl[j][i]+hl[j][i]+ll[j][i];
      hl[j][i]=r1/dt;
    }
  return;
}


/*********************************************************************
* Function: solpart()
*
***********************************************************************/
void solpart(uu, ud, gg, yl, yr, tbl, tbr, tdl, tdr, lch, asq, zk2,
	work, trigs, xk1, xk2, b, s, c, ifax, wnzd )
float uu[MM2][NDM], ud[MM2][NDM],gg[MM2][NDM],yl[MM2][NEM+NEP1+1],
  yr[MM2][NEM+NEP1+1];
int lch[MM2];
float tbl[MM2],tbr[MM2],tdl[MM2],tdr[MM2],zk2[MM2];
float asq;
float *work,*trigs,*xk1,*xk2,*b,*s,*c;
int *ifax;
float wnzd;
{
  extern void level(),extr(),expand(),partic(),bound();
  float  ewr[NEXT+NEM+1],wu[NDM],wd[NDM],bl,br,drl,drr;
  float wr[NDM];
  float umax,umin;
  float al;
  int j;
  static int K1= -1;
  static int K2= 1;
  int i;
  float wnzd2;

  for (j=0;j<MM2;j++)
    lch[j]=1;
  wnzd2 = wnzd*wnzd;
  
  for(j=1; j<=MM2; j++) {
    /*
      if (j==2) continue;
      */
    
    level(gg,wr,&j,&K1);
    
    /*
      extr(wr,&umax,&umin);
      if ((umax<1.0e-12) && (umin<1.0e-12)) continue;
      */
    /*---------------------------*/
    /* Solution in x-direction   */
    /*---------------------------*/
    
    al=sqrt(asq+zk2[j-1]);
    lch[j-1]=1;
    expand(wr,yr,yl,ewr,&j);
    partic(ewr,wu,wd,&bl,&br,&drl,&drr,&al,work,trigs,
	   ifax,xk1,xk2,b,s,c,wnzd2);
    bound(tbl,tbr,tdl,tdr,&bl,&br,&drl,&drr,&j,&K1);
    level(uu,wu,&j,&K2);
    level(ud,wd,&j,&K2);
  }
  return;
}


/*******************************************************************
* Function: extr()
*
*********************************************************************/
void extr(wr, umax, umin)
float wr[NDM],*umax,*umin;
{
  static int i;
  static float r;
  
  *umax = -100000.0;
  *umin = 100000.0;
  for(i=0; i<NDM; i++) {
    r = wr[i];
    if (r>*umax) *umax=r;
    if (r<*umin) *umin=r;
    /*
     *umax = max(r,*umax);
     *umin = min(r,*umin);
     */
  }
  *umax=fabs(*umax);
  *umin=fabs(*umin);
  return;
}


/*******************************************************************
* Function: partic()
*
*********************************************************************/
void partic(rhl, up, udp, bl, br, drl, drr, al,
	    work, trigs, ifax, xk1, xk2, b, s, c, wnzd)
float rhl[NEXT+NEM+1],up[NDM],udp[NDM];
float *bl,*br,*drl,*drr,*al;
float *work,*trigs;
float *xk1,*xk2;
int *ifax;
float *b,*s,*c;
float wnzd;
{
  extern void project(),extend(),fft1(),dint(),copy(),fftinvers(),der1();
  static int i;
  static float ad1[M][NP2],a[M][NP2],z[NXH];
  
  project(rhl,z,b,s,c);
  extend(a,z);
  fft1(a,work,trigs,ifax);
  dint(a,al,xk2, wnzd);
  copy(a,ad1);
  fftinvers(a,work,trigs,ifax);
  der1(ad1,xk1);
  fftinvers(ad1,work,trigs,ifax);
  
  for(i=1; i<=(NDM); i++) {
    up[i-1] = a[0][i+(NEP)-1];
    udp[i-1] = ad1[0][i+(NEP)-1];
  }
  *bl = *up;
  *br = up[(NDM)-1];
  *drl = *udp;
  *drr = udp[(NDM)-1];
  return;
}


/*********************************************************************
* Function: bound()
*
***********************************************************************/
void bound(tbl, tbr, tdl, tdr, bl, br, drl, drr, jj, id)
int *jj,*id;
float *bl,*br,*drl,*drr;
float tbl[MM2],tbr[MM2],tdl[MM2],tdr[MM2];
{

  if(*id < 0) {
    tbl[*jj-1] = *bl;
    tbr[*jj-1] = *br;
    tdl[*jj-1] = *drl;
    tdr[*jj-1] = *drr;
  }
  else  {
    *bl = tbl[*jj-1];
    *br = tbr[*jj-1];
    *drl =tdl[*jj-1];
    *drr = tdr[*jj-1];
  }
  return;
}


/*******************************************************************
* Function: dint()
*
*********************************************************************/
void dint(a, al, xk2, wnzd2)
float a[M][NP2],*al;
float *xk2;
float wnzd2;
{
  
  /*--------------------------------------------------------------------*/
  /*  calculate fourier-coeff. for U, U''-AL*AL*U=F, Uj=-Fj/(j*j+AL*AL) */
  /*--------------------------------------------------------------------*/
  static int i,ii1,ii2,is;
  static float zz;
  static float che;
  che=1.0e-6;
  
  if( (*al < che) && (wnzd2 < che) ){
    a[0][0]=0.0;
    is=2;
  }
  else
    is=1;
  
  for(i=is; i<=(NXH); i++){
    ii1 = 2*i-1;
    ii2 = 2*i;
    zz = xk2[i-1]+*al**al+wnzd2;
    a[0][ii1-1] =  -a[0][ii1-1]/zz;
    a[0][ii2-1] =  -a[0][ii2-1]/zz;
  }
  a[0][1] = 0.0;
  return;
}


/*******************************************************************
* Function: copy()
*
*********************************************************************/
void copy(a, b)
float a[M][NP2],b[M][NP2];
{
  static int i,j;

  for(i=0; i<(NP2); i++) {
    for(j=0; j<(M); j++) b[j][i] = a[j][i];
  }
  return;
}


/*******************************************************************
* Function: aver()
*
*********************************************************************/
void aver(wu, sav)
float wu[NDM],*sav;
{
  int i;
  float sum;
  
  sum=0.0;
  for (i=0;i<NDMM;i++)
    sum+=wu[i];
  
  *sav=sum/NDMM;
  return;
}


/***********************************************************************
* Function: gmatch()
*
***********************************************************************/
void gmatch(ybl, ybr, ydl, ydr, dl1, tbl, tbr, tdl, tdr, lch, zk1, pav, wnzd)
float ybl[NPR][KK2][MM2],ybr[NPR][KK2][MM2],ydl[NPR][KK2][MM2],
  ydr[NPR][KK2][MM2],tbl[KK2][MM2],tbr[KK2][MM2],tdl[KK2][MM2],
  tdr[KK2][MM2];
float dl1,pav;
float zk1[MM2], wnzd[KK2];
int lch[KK2][MM2];
{
  extern void matchparam(),matchcoef(),match0();
  int j,nk,lc,i,k;
  float al;
  float cc[NPR],dd[NPR];
  float st1[NPR1],st2[NPR1];
  float bl[NPR],br[NPR],drr[NPR],drl[NPR];
  
  for( k = 0; k < KK2; k++ ){
    for (j=0;j<MM2;j++){
      lc=lch[k][j];
      /*
        if (lc==0) continue;
	*/
      al=sqrt( zk1[j]*zk1[j] + wnzd[k]*wnzd[k] );

      if( al != 0.0 ){
	bl[0]=tbl[k][j];
        br[0]=tbr[k][j];
        drl[0]=tdl[k][j];
        drr[0]=tdr[k][j];

        for (nk=1;nk<NPR;nk++){
	  bl[nk]=ybl[nk][k][j];
	  br[nk]=ybr[nk][k][j];
	  drl[nk]=ydl[nk][k][j];
	  drr[nk]=ydr[nk][k][j];
	}
	
	matchparam(st1,st2,br,bl,drr,drl,al);
	matchcoef(st1,st2,cc,dd,al,dl1);

        for (nk=1;nk<NPR;nk++){
	  ybl[nk][k][j]=cc[nk];
	  ybr[nk][k][j]=dd[nk];
	}
        tbl[k][j]=cc[0];
        tbr[k][j]=dd[0];
      } /* if( ( k != 0 ) && ( j != 0 ) ) */
    } /* for j==2 */
  }
  
  j=0;
  k=0; 		
  bl[0]=tbl[k][j];
  drl[0]=tdl[k][j];
  drr[0]=tdr[k][j];
  for (nk=1;nk<NPR;nk++){
    bl[nk]=ybl[nk][k][j];
    drl[nk]=ydl[nk][k][j];
    drr[nk]=ydr[nk][k][j];
  }
  match0(bl,drl,drr,pav);
  for (nk=1;nk<NPR;nk++)
    ybl[nk][k][j]=bl[nk];
  tbl[0][0]=bl[0];
  return;
}


/*******************************************************************
* Function: matchparam()
*
********************************************************************/
void matchparam(st1,st2,br,bl,drr,drl,al)
float st1[NPR1],st2[NPR1];
float bl[NPR],br[NPR],drr[NPR],drl[NPR];
float al;
{
  int i;
  float r1,r2;

  for (i=2;i<=NPR;i++){
    st1[i-1]=0.5*(br[i-2]-bl[i-1]+(drr[i-2]-drl[i-1])/al);
    st2[i-1]=0.5*(br[i-2]-bl[i-1]-(drr[i-2]-drl[i-1])/al);
  }
  r1=br[NPR-1]-bl[0];
  r2=drr[NPR-1]-drl[0];
  st1[0]=0.5*(r1+r2/al);
  st2[NPR1-1]=0.5*(r1-r2/al);
  return;
}


/*********************************************************************
* Function: matchcoef()
*    for periodic boundary conditions
*
**********************************************************************/
void matchcoef(st1, st2, cc, dd, al, dl1)
float st1[NPR1],st2[NPR1],cc[NPR],dd[NPR];
float al,dl1;
{
  float ar,rr,ep,tin,suma,sumb;
  int nk,nkm,nxp, nkp;
  int i;
  
  ar=-al*dl1;
  rr=exp(ar);
  ep=exp(ar*NPR);
  tin=1.0-ep;
  suma=0.0;
  sumb=0.0;
  for (nk=1;nk<=NPR;nk++){
    nkm=nk-1;
    nkp=nk+1;
    nxp=NPR-nk;
    suma+=st1[nk-1]*exp(nkm*ar);
    sumb+=st2[nkp-1]*exp(nxp*ar);
  }
  cc[NPR-1]=-suma/tin;
  dd[0]=sumb/tin;
  
  for (nk=NPR;nk>=2;nk--)
    cc[nk-2]=cc[nk-1]*rr-st1[nk-1];
  
  for (nk=1;nk<=NPR-1;nk++){
    nxp=nk+1;
    dd[nxp-1]=dd[nk-1]*rr+st2[nxp-1];
  }
  return;
}


/*******************************************************************
* Function: match0()
*     <P'>_n   in BL(n)
*
*     P'_n = P'_n + alph_n,   alph_n return in BL(n)
*     Input and output in Fourier space
*     NL={G,H}
*     G=-C V,  H = C U;   C=Vx-Uy (vorticity)
*
*********************************************************************/
void match0(bl, drl, drr, pav)
float bl[NPR],drl[NPR],drr[NPR];
float pav;
{
  float br[NPR],sum,s;
  int nk;
  
  br[0]=0.0;
  for (nk=1;nk<NPR;nk++)
    br[nk]=br[nk-1]+drr[nk-1]-drl[nk];
  
  sum=0.0;
  for (nk=0;nk<NPR;nk++)
    sum+=bl[nk]+br[nk];
  
  s=sum/NPR;
  
  for (nk=0;nk<NPR;nk++)
    bl[nk]=br[nk]+pav-s;
  
  return;
}


/*******************************************************************
* Function: match3()
*
*********************************************************************/
void match3(gl, hl, tbl, tbr, zk1, de, del1, wnzd)
float gl[KK2][MM2][NDM],hl[KK2][MM2][NDM],tbl[KK2][MM2],tbr[KK2][MM2],
  zk1[MM2],de, del1, wnzd[KK2];
{
  extern void boundp(),level(),corv();
  float al,cc,dd;
  float wu[NDM],wd[NDM];
  int i,j,k;
  static int K1=1;
  static int K2=-1;
  
  for( k = 0; k < KK2; k++ ){
    for (j=1;j<=MM2;j++){
      al=sqrt(zk1[j-1]*zk1[j-1]+wnzd[k]*wnzd[k]);
      if( al != 0.0 ){
	boundp(tbl[k],tbr[k],&cc,&dd,j);
	level(gl[k],wu,&j,&K2);
	level(hl[k],wd,&j,&K2);
	corv(cc,dd,wu,wd,al,de,del1);
	level(gl[k],wu,&j,&K1);
	level(hl[k],wd,&j,&K1);
      }
    }
  }
  for (i=0;i<NDM;i++)
    hl[0][0][i]+=tbl[0][0];
  return;
}


/*******************************************************************
* Function: boundp()
*
*********************************************************************/
void boundp(tbl, tbr, cc, dd, j)
float tbl[MM2],tbr[MM2],*cc,*dd;
int j;
{

  *cc=tbl[j-1];
  *dd=tbr[j-1];
  return;
}


/*******************************************************************
* Function: corv()
*
*********************************************************************/
void corv(cc, dd, wu, wd, al, de, dl1)
float cc,dd,wu[NDM],wd[NDM],al,de,dl1;
{
  int i;
  float xx,arg,arg1,r1,r2,uh,udh;
  
  for (i=1;i<=NDM;i++){
    xx=de*(float)(i-1);
    arg=al*xx;
    arg1=al*(xx-dl1);
    uh=cc*exp(arg1) + dd*exp(-arg);
    udh=cc*exp(arg1) - dd*exp(-arg);
    r1=wu[i-1];
    r2=wd[i-1];
    wu[i-1]=uh+r1;
    wd[i-1]=al*udh+r2;
  }
  return;
}


/******************************************************************
* Function: rhsim()
*
********************************************************************/
void rhsim(uu, vv, ww, hl, gl, ll, dt, et)
float
uu[MM2][NDM],hl[MM2][NDM],gl[MM2][NDM],
  vv[MM2][NDM], ww[MM2][NDM],ll[MM2][NDM];
float dt,et;
{
  int  j,i;
  float  r1,r2,r3;

  for(j=0; j<(MM2); j++) {
    for(i=0; i<(NDM); i++) {
      r1 = uu[j][i]/dt - hl[j][i];
      r2 = vv[j][i]/dt - gl[j][i];
      r3 = ww[j][i]/dt - ll[j][i]; 		
      gl[j][i] = -r1/et;
      hl[j][i] = -r2/et;
      ll[j][i] = -r3/et;
    }
  }
  return;
}


/*******************************************************************
* Function: error()
*
*********************************************************************/
void error(uu, hh, err, ct)
float uu[KK2][MM2][NDM],hh[KK2][MM2][NDM],*err,ct;
{
  int j,i,k;
  float r;

  *err = 0.0;
  for( k = 0; k < KK2; k++ ){
    for(j=0; j<(MM2); j++) {
      for(i=0; i<(NDM); i++) {
	r = fabs(uu[k][j][i]-ct*hh[k][j][i]);
	if (r>*err) *err=r;
	/* 
	 *err = max(r,*err); 
	 */
      }
    }
  }
  return;
}


/*******************************************************************
* Function: match1()
*
*********************************************************************/
void match1(uu, ybl, ybr, ydl, ydr, tbl, tbr,
	    tdl, tdr, lch, zk2, asq, de, dl1, wnzd)
float uu[MM2][NDM],ybl[MM2],ybr[MM2],ydl[MM2],ydr[MM2],tbl[MM2],tbr[MM2],
  tdl[MM2],tdr[MM2],zk2[MM2];
int lch[MM2];
float asq,de,dl1,wnzd;
{
  extern void bound(),matchpar(),level(),coru();
  float al,bl,cbl,br,cbr,drl,cdrl,drr,cdrr;
  float cc,dd;
  float wu[NDM];
  int j,lc;
  static int K1=1;
  static int K2=-1;
  
  for (j=1;j<=MM2;j++){
    /*-------------------------*/
    /* LAMBDA on j-level       */
    /*-------------------------*/
    al=sqrt(asq+zk2[j-1]+ wnzd*wnzd);
    lc=lch[j-1];
    /*
      if (lc==0) continue;
      */
    
    bound(tbl,tbr,tdl,tdr,&bl,&br,&drl,&drr,&j,&K1);
    bound(ybl,ybr,ydl,ydr,&cbl,&cbr,&cdrl,&cdrr,&j,&K1);
    matchpar(bl,br,drl,drr,cbl,cbr,cdrl,cdrr,al,&cc,&dd);
    level(uu,wu,&j,&K2);
    coru(cc,dd,wu,al,de,dl1);
    level(uu,wu,&j,&K1);
  }
  return;
}


/*********************************************************************
* Function: coru()
*
***********************************************************************/
void coru(cc, dd, wu, al, de, dl1)
float cc,dd,wu[NDM],al,de,dl1;
{
  int i;
  float xx,arg,arg1,r1,uh;
  
  for (i=1;i<=NDM;i++){
    xx=de*(float)(i-1);
    arg=al*xx;
    arg1=al*(xx-dl1);
    uh=cc*exp(arg1) + dd*exp(-arg);
    r1=wu[i-1];
    wu[i-1]=uh+r1;
  }
  return;
}


/*********************************************************************
* Function: matchpar()
*    calculate coefficients of match procedure cc,dd
*
**********************************************************************/
void matchpar(bl, br, drl, drr, cbl, cbr, cdrl, cdrr, al, cc, dd)
float bl,br,drl,drr,cbl,cbr,cdrl,cdrr,al,*cc,*dd;
{
  float d,dm,ds,dsm;

  d=br-cbr;
  dm=cbl-bl;
  ds=(drr-cdrr)/al;
  dsm=(cdrl-drl)/al;
  *cc=-(d+ds)/2.0;
  *dd=(dm-dsm)/2.0;
  return;
}


/*********************************************************************
* Function: match2()
*
************************************************************************/
void match2(vv, vd, ybl, ybr, ydl, ydr, tbl,
	    tbr, tdl, tdr, lch, zk2, asq, de, dl1, wnzd)
float vv[MM2][NDM],vd[MM2][NDM],ybl[MM2],ybr[MM2],ydl[MM2],ydr[MM2],tbl[MM2],
  tbr[MM2],tdl[MM2],tdr[MM2],zk2[MM2];
int lch[MM2];
float asq,de,dl1,wnzd;
{
  extern void bound(),matchpar(),level(),corv();
  float al,bl,cbl,br,cbr,drl,cdrl,drr,cdrr;
  float cc,dd;
  float wu[NDM],wd[NDM];
  int j,lc;
  static int K1=1;
  static int K2=-1;
  
  for (j=1;j<=MM2;j++){
    /*-------------------------*/
    /* LAMBDA on j-level       */
    /*-------------------------*/
    al=sqrt(asq+zk2[j-1] + wnzd*wnzd);
    lc=lch[j-1];
    /*  
	if (lc==0) 
	continue;
	*/
    
    bound(tbl,tbr,tdl,tdr,&bl,&br,&drl,&drr,&j,&K1);
    bound(ybl,ybr,ydl,ydr,&cbl,&cbr,&cdrl,&cdrr,&j,&K1);
    matchpar(bl,br,drl,drr,cbl,cbr,cdrl,cdrr,al,&cc,&dd);
    level(vv,wu,&j,&K2);
    level(vd,wd,&j,&K2);
    corv(cc,dd,wu,wd,al,de,dl1);
    level(vv,wu,&j,&K1);
    level(vd,wd,&j,&K1);
  }
  return;
}
